/* $Id: linpol.c,v 1.1 1999/03/04 11:30:35 rpalsa Exp $   
 *
 *.IDENT       $RCSfile: linpol.c,v $
 *
 *.KEYWORDS    Perform linear interpolation in a sub interval
 *
 *.USAGE       double linpol(double x0, double y0, double x1, double y1,
 *                           double x)
 *
 *.INPUT 
 *             x0      x-axis value of first data point
 *             y0      y-axis value of first data point
 *             x1      x-axis value of second data point
 *             y1      y-axis value of second data point
 *             x       x-axis value of data point for which y shall be
 *                     determined
 *
 *.OUTPUT      None
 *
 *.RETURNS     The function returns the interpolated value y
 *
 *.PURPOSE     The function calculates y from y = (y1-y0)/(x1-x0) *
 *             (x-x0) + y0 assuming that the function y = f(x) may be 
 *             represented by a straight line in the interval [x0,x1].
 *
 *.ENVIRON     None
 *
 *.LANGUAGE    ANSI C/KR C
 *
 *.AUTHOR      R. Palsa, Univ.-Sternwarte Muenchen
 *
 *.VERSION     0.1 1996/12/31: Creation (RP)
 *             0.2 1999/02/28: Support KR C, Header changed to MIDAS
 *                             standard (RP)
 *
 *----------------------------------------------------------------------------
 */


#ifdef __STDC__
double linpol(double x0, double y0, double x1, double y1, double x)
#else
double linpol(x0, y0, x1, y1, x)
     double x0, y0, x1, y1, x;
#endif
{

  return (y1 - y0)/(x1 - x0) * (x - x0) + y0;

}
