! $Id: fors_append.prg,v 1.16 1999/11/25 11:23:46 sbogun Exp $
!+++ FORS_APPEND ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT       $RCSfile: fors_append.prg,v $
!
!.KEYWORDS      Concatenate message text to be send to fors_message.prg
!
!.USAGE         @p fors_append text
!
!.INPUT         text    (P1): line to be appended
!
!.OUTPUT        
!
!.RETURN        Q1:  0: successful return
!                   -1: a successful return failed
!
!.DEFAULT
!
!.PURPOSE       Append text to already existing text buffer CBUF.
!               This text buffer may be put on the terminal by using
!               fors_messages:
!                       @p fors_messages 3 prgname
!
!               Further information see fors_messages.
!
!.ALGORITHM     Append text to already existing text buffer CBUF.
!
!.ENVIRON       FORS, CCDRED context
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       0.5 1998/03/04  Creation
!
!.COMMENT       This procedure allows to handle characterbuffer with any size.
!               Usually, MIDAS allows only 100 character to be entered by one
!               command (WRITE/KEY).
!------------------------------------------------------------------------------
!
! Check parameters
!
define/param p1 ? c "text line: "

define/local CLEN/i/1/1 0
define/local LLEN/i/1/1 0
define/local LINE/c/1/100
define/local csz/i/1/1 0

!copy key P1 line
line = {P1}
llen = m$strlen(line)                   !length of input text

info/keyw CBUF
csz = mid$info(2)                       !size of character keyword CBUF
if mid$info(1) .eq. 0 then              !character buffer does not exist
  @p fors_max 500,{llen}
  clen = {Q1}
  write/key CBUF/c/1/{clen} " " ALL     !--> create
else                                    !character buffer does already exist.
  clen = m$strlen(CBUF)                 !length of text already in the buffer.
  llen = llen + clen                    !total length of changed buffer.
  clen = csz                            !actual size of character buffer.
  if clen .lt. llen then                !we have to increase the buffer
    define/local TBUF/c/1/{clen} " " ALL        !--> create temporary buffer
    copy/kk CBUF TBUF
    delete/keyw CBUF
    clen = 2 * clen
    @p fors_max {clen},{llen}
    clen = {Q1}
    write/key CBUF/c/1/{clen} " " ALL           !--> create
    copy/kk TBUF/c/1/{clen} CBUF/c/1/{clen}     !restore old buffer
  endif
endif
llen = 100                              !now: max.size of the input buffer

!write/out {LINE} {LLEN}
!write/out {CBUF} {CLEN}

run PIPE_EXE:fors_append.exe
return 0
