! $Id: fors_cfglabel.prg,v 1.1 1998/11/25 17:08:57 rpalsa Exp $   
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT   (C) 1998  European Southern Observatory (ESO)
!
!.IDENT       $RCSfile: fors_cfglabel.prg,v $
!
!.KEYWORDS    Display labels, setup, fonts, colors
!
!.USAGE       config/label
!
!.INPUT       None
!
!.OUTPUT      Keyword OUTPUTi(1) holds the font index.
!             Keyword OUPUTC holds the label color name.
!
!.RETURNS     The recipe returns 0 on success, otherwise 1. Keyword Q1 is
!             updated with the exit status. 
!
!.PURPOSE     Get label font and color as set by a previous call of LOAD/IMAGE
!             within the pipeline environment. If the pipeline environment
!             is not found (i.e the keyword PIPELINE_AUX) default values
!             (font: 0, color: white) will be returned.
!
!.ENVIRON     FORS context
!
!.LANGUAGE    MIDAS command language 98NOV.
!
!.AUTHOR      R. Palsa, ESO-DMO
!
!.VERSION     0.5  1998/11/25:  Creation
!
!------------------------------------------------------------------------------

define/maxpar 0


! Procedure identification
define/local procID/c/1/80      "CfgLabel"


! Local constants
define/local fntdef/i/1/1 0
define/local coldef/c/1/5 "white"



! Get annotation color and font. Color 0 (erase) is not supported.
if m$existk("pipeline_aux") .eq. 1 then
  outputi(1) = pipeline_aux(2)

  if pipeline_aux(1) .eq. 1 then
    outputc = "black"
  else if pipeline_aux(1) .eq. 2 then
    outputc = "white"
  else if pipeline_aux(1) .eq. 3 then
    outputc = "red"
  else if pipeline_aux(1) .eq. 4 then
    outputc = "green"
  else if pipeline_aux(1) .eq. 5 then
    outputc = "blue"
  else if pipeline_aux(1) .eq. 6 then
    outputc = "yellow"
  else if pipeline_aux(1) .eq. 7 then
    outputc = "magenta"
  else if pipeline_aux(1) .eq. 8 then
    outputc = "cyan"
  else
    outputc = coldef
    return 1
  endif
else
  outputi(1) = fntdef
  outputc = coldef
  return 1
endif

return 0
