! $Id: fors_checkrsp.prg,v 1.2 1999/03/17 11:01:39 rpalsa Exp $   
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT   (C) 1999  European Southern Observatory (ESO)
!
!.IDENT       $RCSfile: fors_checkrsp.prg,v $
!
!.KEYWORDS    Check instrument response
!
!.USAGE       check/response response
!
!.INPUT       response (P1)   Response frame to be checked.
!
!.OUTPUT      None.
!
!.RETURNS     The recipe returns 0 on success, otherwise 1. Keyword Q1 is
!             updated with the exit status. 
!
!.PURPOSE     Checks if the input response frame has response values out
!             of the allowed range [0.,1.].
!
!.ENVIRON     FORS context, XMOS context
!
!.LANGUAGE    MIDAS command language 98NOV.
!
!.AUTHOR      R. Palsa, ESO-DMO
!
!.VERSION     0.5  1999/03/10:  Creation
!
!------------------------------------------------------------------------------

crossref  response

define/param p1 ? c "Enter response frame:"
define/maxpar 1


! Procedure identification
define/local procID/c/1/80      "CheckResponse"


! Local variables
define/local rspmin/r/1/1  -1.e-5
define/local rspmax/r/1/1  1.


! Local variables
define/local frm/c/1/100  {p1}



! Process parameters
if m$filtyp(frm,".bdf") .eq. 2 then
  statistics/table {frm} :{c_rsratio} >Null
else
  statistics/image {frm} option=XN
endif

if outputr(1) .lt. {rspmin} .or. outputr(2) .gt. {rspmax} then
  return 1
endif

return 0
