! $Id: fors_chfitshdr.prg,v 1.4 2000/09/28 12:32:01 nrainer Exp $   
!+++ FORS_CHFITSHDR ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! Author: Sebastian Wolf @ESO                               Date:   98-02-04
! Purpose:
!   Adds FITS header keywords
! Algorithm:
!   x
! Context:
!   MIDAS ccdred
!
! Input:
!   P1: file pattern of group of files to be changed (e.g.: f*.fits)
!   P2: file type to be processed (Image, Table)
!   P3: descriptor name+definition to be added or changed (ESO.DPR.TYPE/c/1/15)
!   P4: descriptor value to be inserted (BIAS)
!   P5: extension of outputfiles (used by outdisk/fits) [.fits]
! Output:
!   Changed INPUT file
!
!---------------------------------------------------------------------------
echo/off
!
! Check parameters
!
define/param P1 ? c  "Group of files to be changed (e.g.: f*.fits):"
define/param P2 ? c  "File type to be processed (Image, Table):"
define/param P3 ? c  "Descriptor to be added or changed (ESO.DPR.TYPE/c/1/15):"
define/param P4 ? c  "Descriptor value to be inserted (BIAS):"
!define/param P5 ? c  "extension of outputfiles (used by outdisk/fits):"
!
! local variable declaration
!
define/local catal/i/1/1 0
define/local ext/c/1/100 " " ALL

if P2(1:1) .eq. "I" .OR. P2(1:1) .eq. "i" then
  creat/icat &c.cat {P1}
else if P2(1:1) .eq. "T" .OR. P2(1:1) .eq. "t" then
  creat/tcat &c.cat {P1}
endif

store/frame ext middummc.cat
@p fors_parsepath {ext}
ext = "{Q3}"
if ext(1:1) .eq. " " ext = ".fits"

wr/setup catalog 1,3 3 NO ? 0 C
!info/setup catalog
!exec/cat del/descr middummc.cat {P3}
exec/cata indisk/fits middummc.cat ROOT=trans  IMAGE 
if P2(1:1) .eq. "I" .OR. P2(1:1) .eq. "i" then
  creat/icat &b.cat {P1(1:1)}*.bdf
else if P2(1:1) .eq. "T" .OR. P2(1:1) .eq. "t" then
  creat/tcat &b.cat {P1(1:1)}*.tbl
endif

exec/cat wri/descr middummb.cat {P3} {P4}
exec/cata outdisk/fits middummb.cat NAME=INPUT  IMAGE  {ext}
!exec/cata outdisk/fits middummb.cat NAME=INPUT  IMAGE  {ext}
