! $Id: fors_cleanpipe.prg,v 1.1 1999/01/14 13:40:10 rpalsa Exp $   
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT   (C) 1998  European Southern Observatory (ESO)
!
!.IDENT       $RCSfile: fors_cleanpipe.prg,v $
!
!.KEYWORDS    Pipeline emergency shutdown
!
!.USAGE       clean/pipeline ctx
!
!.INPUT       ctx         (P1)    Context identifier(s)
!
!.OUTPUT      None
!
!.RETURNS     The procedure returns 0 on success, otherwise 1. If the command
!             is used while the recipe is running in a recipe queue (super
!             recipe) the exit status is 2 and no contexts are deleted from
!             the environment. The keyword Q1 is updated with the exit status.
!
!.PURPOSE     The procedure disables the context(s) provided by the comma
!             seperated list of context identifiers.
!
!.ENVIRON     FORS context
!
!.LANGUAGE    MIDAS command language 98NOV.
!
!.AUTHOR      R. Palsa, ESO-DMO
!
!.VERSION     0.5  1998/04/01:  Creation
!
!------------------------------------------------------------------------------

crossref context

define/param p1  +      c    "Context identifier:"
define/maxpar 1


! Procedure identification
define/local procID/c/1/80	"CleanPipe"


! Local variables
define/local i/i/1/1       0
define/local nctx/i/1/1    0
define/local ctx/c/1/100   {p1}



if m$existk("pipeline") .eq. 1 then
  if pipeline(6) .ne. 1 then
    ctx = m$lower(ctx)
    nctx = m$parse(ctx,"ctx")

    set/format i2
    do i = 1 nctx 1
      show/context {ctx{i}}
      if outputi(5) .gt. 0 then
        clear/context {ctx{i}}
      else
        mess/out 4 {procID} "Context {ctx{i}} was not loaded!"
      endif
    enddo
    set/format
  else
    return 2
  endif
else
  mess/out 1 {procID} "No pipeline environment present!"
endif


return 0
