! $Id: fors_combtab.prg,v 1.7 2000/02/08 10:25:39 sbogun Exp $   
!+++ FORS_COMBTAB ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT       $RCSfile: fors_combtab.prg,v $
!
!.KEYWORDS      Combine overscan tables
!
!.USAGE         @p fors_combtab preflg posflg pretbl postbl suff partbl1 partbl2
!
!.INPUT         preflg  (P1): set of input frames (ascii list)
!               posflg  (P2): set of reference frames (ascii list)
!               pretbl  (P3): optional parameter
!               postbl  (P4): optional parameter
!               suff    (P5)
!               partbl1 (P6): optional parameter
!               partbl2 (P7): optional parameter
!
!.OUTPUT        merged or renamed table
!
!.RETURN        Q1:  0: successful return
!                   -1: a successful return failed
!
!.DEFAULT
!
!.PURPOSE       Create a combination of pre-/postscan tables.
!               Used by recipe: fors_gen_qc0_overscan
!
!.ALGORITHM     
!
!.ENVIRON       
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       0.5 1998/02/04  Creation
!
!.COMMENT
!------------------------------------------------------------------------------
!
! local variable declaration
!
define/local done/i/1/1 0
done = {P1} + {P2}

BRANCH {done} 2,1,0 BTH,SNG,NXT
goto NXT

BTH:
  MERGE/TAB prescan{P3} postscan{P3} overscan{P3}
  -delete prescan{P3}
  -delete postscan{P3}
  write/descr overscan{P3}.tbl PRE_P1/r/1/1 {{P4},:RESULT,1}
  write/descr overscan{P3}.tbl PRE_P2/r/1/1 {{P4},:RESULT,2}
  write/descr overscan{P3}.tbl PRE_P3/r/1/1 {{P4},:RESULT,3}
  write/descr overscan{P3}.tbl POST_P1/r/1/1 {{P5},:RESULT,1}
  write/descr overscan{P3}.tbl POST_P2/r/1/1 {{P5},:RESULT,2}
  write/descr overscan{P3}.tbl POST_P3/r/1/1 {{P5},:RESULT,3}
  goto NXT
SNG:
  if {P1} .eq. 1 then
    RENAME/TAB prescan{P3} overscan{P3}
    write/descr overscan{P3}.tbl PRE_P1/r/1/1 {{P4},:RESULT,1}
    write/descr overscan{P3}.tbl PRE_P2/r/1/1 {{P4},:RESULT,2}
    write/descr overscan{P3}.tbl PRE_P3/r/1/1 {{P4},:RESULT,3}
  else if {P2} .eq. 1 then
    RENAME/TAB postscan{P3} overscan{P3}
    write/descr overscan{P3}.tbl POST_P1/r/1/1 {{P5},:RESULT,1}
    write/descr overscan{P3}.tbl POST_P2/r/1/1 {{P5},:RESULT,2}
    write/descr overscan{P3}.tbl POST_P3/r/1/1 {{P5},:RESULT,3}
  endif
NXT:
!end.
