! $Id: fors_convextract.prg,v 1.4 1999/03/15 20:35:59 rpalsa Exp $   
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT   (C) 1998  European Southern Observatory (ESO)
!
!.IDENT       $RCSfile: fors_convextract.prg,v $
!
!.KEYWORDS    Spectrum conversion, spectroscopy, flux calibration
!
!.USAGE       convert/extract objects spectra
!
!.INPUT       frame       (P1)    Input frame with object spectrum.
!             windows     (P2)    Table with object windows.
!
!.OUTPUT      flxtbl      (P3)    Extracted spectrum table.
!
!.RETURNS     The recipe returns 0 on success, otherwise 1. Keyword Q1 is
!             updated with the exit status. 
!
!.PURPOSE     Convert extracted spectra from MOS commanf EXTRACT/MOS
!             to 3d flux table.
!
!.ENVIRON     FORS context, XMOS context
!
!.LANGUAGE    MIDAS command language 98NOV.
!
!.AUTHOR      R. Palsa, ESO-DMO
!
!.VERSION     0.5  1999/01/08:  Creation
!
!------------------------------------------------------------------------------

crossref  frame windows flxtbl

define/param p1 ?    c  "Enter name of object frame:"
define/param p2 ?    c  "Enter MOS window table:"
define/param p3 ?    c  "Enter observed flux table:"
define/maxpar 3


! Procedure identification
define/local procID/c/1/80	"ConvExtract"


! Local variables
define/local spcfrm/c/1/100 {p1}
define/local wintbl/c/1/100 {p2}
define/local spctbl/c/1/100 {p3}



! select object rows from window table and extract them to output
! flux table.
select/table {wintbl} :{c_woslit} .ne. NULL >Null

project/table {wintbl} :{c_woslit},{c_wostart},{c_woend} {spctbl}
copy/tt {wintbl} :{c_radeg} {spctbl} :{c_radeg}
copy/tt {wintbl} :{c_decdeg} {spctbl} :{c_decdeg}
copy/tt {wintbl} :{c_dradeg} {spctbl} :{c_dradeg}
copy/tt {wintbl} :{c_ddecdeg} {spctbl} :{c_ddecdeg}

run PIPE_EXE:fors_convextract.exe
if {q1} .ne. 0 then
  mess/out 1 {procID} "Extracted spectrum conversion failed!"
  return 1
endif

return 0
