! $Id: fors_copyrow.prg,v 1.7 1999/11/25 11:23:51 sbogun Exp $
!+++ FORS_COPYROW +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT       $RCSfile: fors_copyrow.prg,v $
!
!.KEYWORDS      Copy number of rows from a source table to a destination table
!
!.USAGE         @p fors_copyrow src dst rsrc rdst rown col1 coln
!
!.INPUT         src     (P1): name of source table
!               dst     (P2): name of destination table
!               rsrc    (P3): row number to be copied from source
!               rdst    (P4): ... to row number in destination table
!               rown    (P5): number of rows to be copied
!               col1    (P6): number of first destination column
!               coln    (P7): number of columns to be copied
!
!.OUTPUT        Updated destination table
!
!.RETURN        Q1:  0: successful return
!                   -1: a successful return failed
!
!.DEFAULT
!
!.PURPOSE       
!
!.ALGORITHM     X
!
!.ENVIRON       FORS, CCDRED context
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       0.5 1998/02/04  Creation
!
!.COMMENT       The output table has to be created in advance and both have to
!               have the same structure (number and types of columns)!
!------------------------------------------------------------------------------
!
! Check parameters
!
define/param P1 ? c "name of SOURCE table:"
define/param P2 ? c "name of DESTINATION table:"
define/param P3 ? n "row number to be copied from SOURCE:"
define/param P4 ? n "row number in DESTINATION table :"
define/param P5 ? n "number of rows to be copied:"
define/param P6 ? n "number of first destination column:"
define/param P7 ? n "number of columns to be copied:"
!
! local variable declaration
!
define/local i1/i/1/1 0
define/local i2/i/1/1 0
define/local j1/i/1/1 0
define/local k1/i/1/1 0
define/local l1/i/1/1 0
define/local l0/i/1/1 0

!echo/full 3,4
k1 = {P3}                               !row counter (SOUR.)
l1 = {P4}                               !row counter (DEST.)
l0 = l1 - 1
do j1 = 1 {P5} 1                        !row loop
  i2 = {P6}
  do i1 = 1 {P7} 1                      !column loop
    if m$tstno("{{P1},#{i1},{k1}}") .eq. 0 then
      {P2},#{i2},{l1} = "{{P1},#{i1},{k1}}"
    else
      {P2},#{i2},{l1} = m$value({P1},#{i1},{k1})
    endif
    i2 = i2 + 1
  enddo
  k1 = k1 + 1
  l1 = l1 + 1
enddo
