! $Id: fors_corr_cosm.prg,v 1.6 2000/09/28 12:32:00 nrainer Exp $   
!+++ FORS_CORR_COSM ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! Author: Sebastian Wolf @ESO                               Date:   97-11-19
! Purpose:
!   Correct frames specified in a MIDAS-catalog for cosmics using the
!   MIDAS command filter/cosmic. If the catalog is not specified then the
!   frame keywords -- CCD_IN, SC_FFFRM, SC_BSFRM, and SC_DKFRM -- of the
!   CCDRED context are used.
! Algorithm:
!
! Context:
!   MIDAS ccdred
!
! Input:
!   P1: name of input set MIDAS-catalog
! Caution:
!   Uses the READON keyword (readout-noise) of the CCDRED context, so
!   be sure that it is properly set (e.g. by load/ccd)
!---------------------------------------------------------------------------
!
! Check parameters
!
define/param p1 none c "Enter name of MIDAS-catalog:"

define/local indx/i/1/1 0
define/local catal/i/1/1 0
define/local ifrm/c/1/80 " "
define/local warn1/c/1/80 " "
warn1 = "WARNING: frame {ifrm} does not exist ! --> NO reduction."

if m$exist("{p1}") .eq. 0 then	!no catalog specified, use CCDRED-keywords
  stat/ima {CCD_IN} ? ? ? SN
  @p fors_r_cosmic {CCD_IN} p3=5. p7=1  
  stat/ima {SC_FFFRM} ? ? ? SN
  @p fors_r_cosmic {SC_FFFRM} p3=5. p7=1  
  if m$exist("{SC_BSFRM}") .eq. 1 then
    stat/ima {SC_BSFRM} ? ? ? SN
    @p fors_r_cosmic {SC_BSFRM} p3=5. p7=1  
  endif
  if m$exist("{SC_DKFRM}") .eq. 1 then
    stat/ima {SC_DKFRM} ? ? ? SN
    @p fors_r_cosmic {SC_DKFRM} p3=5. p7=1  
  endif
  return
endif

ima_loop:
  store/frame ifrm {p1} 1 finish 
  if m$exist("{ifrm}") .eq. 1 then
!    filter/cosmic {ifrm} &c 0.0,1.0,{READON},4,2
    stat/ima {ifrm} ? ? ? SN
    @p fors_r_cosmic {ifrm} p3=5. p7=1 
!    rename &c {ifrm}
  else
    write/out {warn1}
  endif
goto ima_loop
finish:
