! $Id: fors_creacooref.prg,v 1.2 1999/01/11 16:10:15 rpalsa Exp $   
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT   (C) 1998  European Southern Observatory (ESO)
!
!.IDENT       $RCSfile: fors_creacooref.prg,v $
!
!.KEYWORDS    Artificial image, coordinate references
!
!.USAGE       create/cooref frame cooref
!
!.INPUT       frame       (P1)    Input frame with from which coordinate
!                                 system is extracted
!
!.OUTPUT      cooref      (P2)    Artificial frame with a copy of the
!                                 input coordiante system
!
!.RETURNS     The recipe returns 0 on success, otherwise 1. Keyword Q1 is
!             updated with the exit status. 
!
!.PURPOSE     Copy a frame coordinate system to an arificial image.
!
!.ENVIRON     FORS Context
!
!.LANGUAGE    MIDAS command language 98NOV.
!
!.AUTHOR      R. Palsa, ESO-DMO
!
!.VERSION     0.5  1999/01/04:  Creation
!
!------------------------------------------------------------------------------

crossref  frame cooref

define/param p1 ?    c  "Enter input frame:"
define/param p2 ?    c  "Enter coordinate reference frame:"
define/maxpar 2


! Procedure identification
define/local procID/c/1/80	"CreaCooRef"


! Local variables
define/local dim/i/1/1     0
define/local wcs/i/1/1     0
define/local units/c/1/48  " "  all
define/local frm/c/1/100   {p1}
define/local ref/c/1/100   {p2}



dim = m$value({frm},naxis)
if dim .lt. 1 then
  mess/out 1 {procID} "No axis defined in {frm}!"
  return 1
else if dim .gt. 2 then
  mess/out 1 {procID} "Maximum number of axis allowed is 2!"
  return 1
endif

create/image {ref} = {frm} nodata
 units = m$value({frm},cunit)

if dim .eq. 1 then
  if m$index(units(17:32),"TAN") .gt. 0 then
    wcs = 1
  endif
else
  if m$index(units(17:32),"TAN") .gt. 0 .and. -
     m$index(units(33:48),"TAN") .gt. 0 then
    wcs = 1
  endif
endif

if wcs .eq. 1 then
  copy/dd {frm} refpix {ref}
  copy/dd {frm} crval {ref}
endif

return 0
