! $Id: fors_getcatentry.prg,v 1.3 1999/11/25 11:23:55 sbogun Exp $   
!+++ FORS_GETCATENTRY +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT       $RCSfile: fors_getcatentry.prg,v $
!
!.KEYWORDS      Get catalog entry number or the corresponding entry itself
!
!.USAGE         @p fors_getcatentry catalog entry
!
!.INPUT         catalog (P1): catalog to check
!               entry   (P2): entry or entry number
!
!.OUTPUT        
!
!.RETURN        Depends on type of P2
!               If P2 is a number:
!                       Q1:  corresponding catalog entry (filename)
!                            empty if number exceeds total number of entries
!
!               If P2 is a catalof entry (filename):
!                       Q1: -1: catalog is empty
!                            0: entry not found
!                           >0: corresponding entry number
!
!.DEFAULT
!
!.PURPOSE       Get catalog entry number or the corresponding entry itself
!
!.ALGORITHM     X
!
!.ENVIRON       FORS, CCDRED context
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       1.0 1998/10/06  Creation
!
!.COMMENT
!------------------------------------------------------------------------------
!
! Check parameters
!
define/parameter p1 ? c "Enter catalog name:"
define/parameter p2 ? c "Enter number of desired entry:"

define/local i1/i/1/1 0
define/local num/i/1/1 0
define/local slen/i/1/1 0
define/local fctrl/i/1/2 0 ALL

if m$tstno(P2) .eq. 1 then                      !entry number has been passed

  show/icat {P1} N
  if {P2} .gt. {outputi(1)} return " "

  open/file {P1} READ fctrl
  read/file {fctrl(1)} outputc
  do i1 = 1 {P2} 1
    read/file {fctrl(1)} outputc
  enddo
  i1 = m$len(outputc)
  close/file {fctrl(1)}

  return {outputc(1:{i1})}

else

  show/icat {P1} N
  num = outputi(1)
  if num .eq. 0 return -1

  slen = m$len(P2)
  i1 = -1
  open/file {P1} READ fctrl
loop:
    i1 = i1 + 1
    read/file {fctrl(1)} outputc
    if i1 .lt. num .AND. outputc(1:{slen}) .ne. P2(1:{slen}) goto loop
  close/file {fctrl(1)}

  if outputc(1:{slen}) .eq. P2(1:{slen}) return {i1}
  return 0

endif
