! $Id: fors_getcfg.prg,v 1.6 1998/09/17 12:37:57 rpalsa Exp $   
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT   (C) 1998  European Southern Observatory (ESO)
!
!.IDENT       $RCSfile: fors_getcfg.prg,v $
!
!.KEYWORDS    Data reduction system configuration
!
!.USAGE       config/drs  cat_accept session
!
!.INPUT       cat_accept  (P1)   Name input frame catalog.
!
!.OUTPUT      OUPUTC is updated with the configuration file name.
!
!.RETURNS     The recipe returns 0 on success, otherwise 1. Keyword Q1 is
!             updated with the exit status. 
!
!.PURPOSE     The procedure detects a DRS configuration file in a list of
!             files and returns its name or "NONE" if no configuration file is
!             found.  
!   
!.ENVIRON     FORS context
!
!.LANGUAGE    MIDAS command language 98NOV.
!
!.AUTHOR      R. Palsa, ESO-DMO
!
!.VERSION     0.5  1998/04/01:  Creation
!
!------------------------------------------------------------------------------


define/param p1  ?      c    "Input frame catalog:"


! Procedure identification
define/local procID/c/1/80	"GetConfigFile"



! Local variables
define/local catal/i/1/1       0
define/local cat/c/1/20        {p1}
define/local cat_entry/c/1/80  " "   all



write/key outputc " " all

read_cat_entry:

store/frame cat_entry {cat} 1 exit_loop

if "{{cat_entry},{FORS_IDSTRNG}}" .eq. DRSRC_ID then
  outputc = cat_entry
else
  goto read_cat_entry
endif


exit_loop:

return 0
