! $Id: fors_getlamps.prg,v 1.2 1998/10/16 14:08:23 rpalsa Exp $   
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT   (C) 1998  European Southern Observatory (ESO)
!
!.IDENT       $RCSfile: fors_getlamps.prg,v $
!
!.KEYWORDS    Determine instrument lamp setup
!
!.USAGE       config/lamps  frame
!
!.INPUT       frame    (P1)   Input frame from which the instrument lamp
!                             setup is extracted.
!
!.OUTPUT      None.
!
!.RETURNS     The recipe returns 0 on success, otherwise 1. Keyword Q1 is
!             updated with the exit status. 
!
!.PURPOSE     Get the number and the names of all active lamps.
!
!.ENVIRON     FORS context
!
!.LANGUAGE    MIDAS command language 98NOV.
!
!.AUTHOR      R. Palsa, ESO-DMO
!
!.VERSION     0.5  1998/07/03:  Creation
!
!------------------------------------------------------------------------------

crossref  frame


define/param p1 ? c "Enter name of input frame:"
define/maxpar 1


! Procedure identification
define/local procID/c/1/80      "GetLamps"


! Local variables
define/local i/i/1/1         0
define/local nl/i/1/1        1
define/local lockno/i/1/2    0     all
define/local frame/c/1/100   {p1}
define/local dscname/c/1/80  " "   all



! Unlock keywords if necessary
info/keyw fors_nlamp
lockno(1) = mid$info(4)
if lockno(1) .ne. 0 then
  unlock/key fors_nlamp {lockno(1)}
endif

info/keyw fors_lampi
lockno(2) = mid$info(4)
if lockno(2) .ne. 0 then
  unlock/key fors_lampi {lockno(2)}
endif


! Reset lamp names
do i = 1 FORS_MAXLAMP 1
  fors_lampi({i}) = " "
enddo


! Check for lamp keywords
set/format i1
do i = 1 FORS_MAXLAMP 1
  dscname = kbase_lampi // "{i}" // ksuff_lampi
  if m$existd(frame,dscname) .eq. 1 then
    fors_lampi({nl}) = "{{frame},{dscname}}"
    nl = nl + 1
  endif
enddo
set/format

fors_nlamp = nl - 1


! Protect keywords
if lockno(1) .ne. 0 then
  lock/key fors_nlamp {lockno(1)}
endif

if lockno(2) .ne. 0 then
  lock/key fors_lampi {lockno(2)}
endif

return 0
