! $Id: fors_getwin.prg,v 1.4 1999/11/25 11:23:55 sbogun Exp $   
!+++ FORS_GETWIN ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT       $RCSfile: fors_getwin.prg,v $
!
!.KEYWORDS      Check if frame is a window readout
!
!.USAGE         @p fors_getwin infrm
!
!.INPUT         infrm   (P1): name of input frame
!
!.OUTPUT        
!
!.RETURN        Q1:  0: NO window readout
!                    1: window read
!
!               OUTPUTI: start and end coordinates of the CCD-window are
!                        stored in the elements 1 to 4 (image-pixel-system):
!                        (1),(2): start x and y
!                        (3),(4): end x and y
!
!.DEFAULT
!
!.PURPOSE       Check if frame is a window readout. If so, return coordinates
!
!.ALGORITHM     Compare ESO.DET.CHIP1.NX with NPIX(1). If NPIX(1) is greater
!               than NX then the frame is NO window readout and contains pre-
!               and postscan regions.
!
!.ENVIRON       FORS context
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       1.0 1998/10/26  Creation
!
!.COMMENT       The CCD-coordinates should not be mixed up with the FRAME
!               pixel coordinates which always start with [1,1] at the
!               first pixel !
!               The transformation to frame pixels is simply done by
!               subtracting the starting position and adding 1.
!
!------------------------------------------------------------------------------
define/param p1 c ? "Enter name of image frame: "

define/local procid/c/1/10 getwin

define/local ix/i/1/1 0
define/local iy/i/1/1 0
define/local nx/i/1/1 0
define/local ny/i/1/1 0


write/key outputi 0 all


nx = m$value({P1},{h_chipnx})
ny = m$value({P1},{h_chipny}) - 1       !last row is dumped !!!

ix = m$value({P1},{h_xwinn})
iy = m$value({P1},{h_ywinn})



outputi(1) = m$value({P1},{h_xwinstr})  !get window coordinates
outputi(2) = m$value({P1},{h_ywinstr})
outputi(3) = outputi(1) + ix - 1
outputi(4) = outputi(2) + iy - 1

ix = ix * m$value({P1},{h_xwinbin})
if ix .gt. nx return 0
return 1
