! $Id: fors_initfors.prg,v 1.12 1999/11/25 11:23:56 sbogun Exp $   
!+++ FORS_INITFORS ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT       $RCSfile: fors_initfors.prg,v $
!
!.KEYWORDS      Initialize CCDRED global keywords
!
!.USAGE         @p fors_initfors 
!
!.INPUT         
!
!.OUTPUT        
!
!.RETURN        
!
!.DEFAULT
!
!.PURPOSE       Initialize CCDRED global keywords
!
!.ALGORITHM     Calls initialization procedure INIT/CCD of CCDRED-context
!               and sets some keywords to appropriate descriptors.
!
!.ENVIRON       FORS, CCDRED context
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       0.5 1998/03/10  Creation
!
!.COMMENT       (copy of stdred/ccdred/proc/eso_descr.prg)
!               Uses global keyword FORS_OUTI. Assumes that a previous call
!               of fors_getports has set this keyword properly.
!------------------------------------------------------------------------------

init/ccd

set/format I1

WRITE/KEYW   .IDENT       $RCSfile: fors_initfors.prg,v $
WRITE/KEYW   .OBSER/C/1/20    "{h_observer}"      ! observer descriptor
WRITE/KEYW   .TELES/C/1/20    "{h_telid}"         ! telescope ID descriptor
WRITE/KEYW   .INSTR/C/1/20    "{h_instrume}"      ! instrument ID descriptor
WRITE/KEYW   .DETEC/C/1/20    "{h_detid}"         ! detector ID descriptor
WRITE/KEYW   .BINNING/C/1/20  "{h_xwinbin}"       ! binning in x and y
WRITE/KEYW   .DIRECT/C/1/20   "does not exist"    ! readout direction
WRITE/KEYW   .READMOD/C/1/20  "{h_outmode}"       ! readout mode
WRITE/KEYW   .READON/C/1/20   "does not exist"    ! readout noise per AD unit
WRITE/KEYW   .AD_VAL/C/1/20   "{h_confac({fors_outi(1)})}" ! analog to digit. d.
WRITE/KEYW   EXP_DESC/C/1/20  "{FORS_IDSTRNG}"     ! exposure type descriptor
WRITE/KEYW   O_DESC/C/1/20    "O_TIME(7)"         ! exposure time descriptor
