! $Id: fors_invert.prg,v 1.4 1999/11/25 11:23:56 sbogun Exp $   
!+++ FORS_INVERT ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT       $RCSfile: fors_invert.prg,v $
!
!.KEYWORDS      Matrix inversion
!
!.USAGE         @p fors_invert data nx ny
!
!.INPUT         data    (P1): image or name of a keyword
!               nx      (P2): data dimension n x n matrix
!                             set to a negative value if P1 is an image
!
!.OUTPUT        OUTPUTx or changed INPUT file
!
!.RETURN        Q1:  0: successful return
!                   -1: a successful return failed
!
!.DEFAULT       P2 = -1
!
!.PURPOSE       Perform a matrix inversion
!
!.ALGORITHM     X
!
!.ENVIRON       FORS, CCDRED context
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       1.0 1998/12/01  Creation
!
!.COMMENT       File input not implemented, yet.
!------------------------------------------------------------------------------
define/param P1 ? c "Enter image name or name of keyword: "
define/param P2 -1 c "Enter x-dimension of data matrix (keyword): "
define/param P3 -1 c "Enter y-dimension of data matrix (keyword): "

define/local NX/i/1/1 0
define/local NY/i/1/1 0
define/local DTYP/i/1/1 0

info/key {P1}

IN_A = P1
NX = {P2}

if mid$info(1) .eq. 1 .OR. mid$info(1) .eq. 3 then
  write/out "Not implemented for INTEGER or CHARACTER !"
else
  Dtyp = mid$info(1)
  run PIPE_EXE:fors_invert.exe
endif

