! $Id: fors_max.prg,v 1.12 1999/11/24 09:47:24 sbogun Exp $   
!+++ FORS_MAX ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT       $RCSfile: fors_max.prg,v $
!
!.KEYWORDS      Get the maximum of a number of values
!
!.USAGE         @p fors_max val1,val2,val3,...
!
!.INPUT         val1,val2,val3,... (P1): values of which maximum has to be
!                                        determined
!.OUTPUT        none
!
!.RETURN        Q1:  maximum of val1,val2,val3,...
!
!.DEFAULT
!
!.PURPOSE       Get the maximum of a number of values
!
!.ALGORITHM     write to MIDAS tables and call statistics/table
!
!.ENVIRON       FORS
!   
!.LANGUAGE      MIDAS 99NOV
!
!.AUTHOR        Stefan Bogun, ESO-DMO
!
!.VERSION       1.4 1999/11/05  Creation
!
!.COMMENT
!------------------------------------------------------------------------------
!
! Check parameters
!
define/parameter p1 ? c "enter values separated by commas: "

define/local maxtab/c/1/20   "maxtab.tbl"
define/local i/i/1/1         0
define/local nvalues/i/1/1   0

create/table {maxtab} 1 99 Null
create/column {maxtab} :VALUES " " E23.15 R*8

nvalues = m$parse(p1,"value")

set/format i2
do i = 1 {nvalues} 1
  {maxtab},:VALUES,@{i} = {value{i}}
enddo

statistics/table {maxtab} :VALUES >Null
set/format E23.15,
return {outputr(2)}