! $Id: fors_min.prg,v 1.6 1999/11/24 09:47:25 sbogun Exp $   
!+++ FORS_MIN ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT       $RCSfile: fors_min.prg,v $
!
!.KEYWORDS      Get the minimum of a number of values
!
!.USAGE         @p fors_min val1,val2,val3,...
!
!.INPUT         val1,val2,val3,... (P1): values of which minimum has to be
!                                        determined
!
!.OUTPUT        none
!
!.RETURN        Q1:  minimum of val1,val2,val3,...
!
!.DEFAULT
!
!.PURPOSE       Get the minimum of a number of values
!
!.ALGORITHM     write to MIDAS tables and call statistics/table
!
!.ENVIRON       FORS
!   
!.LANGUAGE      MIDAS 99NOV
!
!.AUTHOR        Stefan Bogun, ESO-DMO
!
!.VERSION       1.4 1999/11/19  Creation
!
!.COMMENT
!------------------------------------------------------------------------------
!
! Check parameters
!
define/parameter p1 ? c "enter values separated by commas: "

define/local mintab/c/1/20   "mintab.tbl"
define/local i/i/1/1         0
define/local nvalues/i/1/1   0

create/table {mintab} 1 99 Null
create/column {mintab} :VALUES " " E23.15 R*8

nvalues = m$parse(p1,"value")

set/format i2
do i = 1 {nvalues} 1
  {mintab},:VALUES,@{i} = {value{i}}
enddo

statistics/table {mintab} :VALUES >Null
set/format E23.15,
return {outputr(1)}
