! $Id: fors_nonlfit.prg,v 1.7 1999/11/25 11:24:01 sbogun Exp $   
!+++ FORS_NONLFIT ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT       $RCSfile: fors_nonlfit.prg,v $
!
!.KEYWORDS      Perform a non linear least squares fit
!
!.USAGE         @p fors_nonlfit dtbl ptbl acc
!
!.INPUT         dtbl    (P1): name of data table
!               ptbl    (P2): name of parameter table
!               accur   (P3): accuracy of fit
!               global keyword:
!                INPUTI: column distribution of the tables (indices):
!                :X   :Y   :SIG   :FIT    :RESIDUAL:PARAM  :FIX    :RESULT
!                 1    2    3      4       5        1       2       3
!               is the expected distribution.
!               set correct column numbers if different, example:
!                 1    2    4      3       5        1       3       2
!
!
!.OUTPUT        updated data and parameter table
!
!.RETURN        Q1:  0: successful return
!                    otherwise: a successful return failed
!               OUTPUTR: CHI^2 of fit
!
!.DEFAULT
!
!.PURPOSE       Perform a non linear least squares fit
!
!.ALGORITHM     Calls fors_nonlfit.exe
!
!.ENVIRON       FORS, CCDRED context
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       0.9 1998/02/04  Creation
!
!.COMMENT
!------------------------------------------------------------------------------
!
! Check parameters
!
define/param p1 ? c "Enter name of data table: "
define/param p2 ? c "Enter name of parameter table: "
define/param p3 ? n "Enter accuracy of fit (chi^2 difference):"
!
! local variable declaration
!

IN_A = P1
IN_B = P2
INPUTR(1) = {P3}

run PIPE_EXE:fors_nonlfit.exe

return {Q1}
