! $Id: fors_outname.prg,v 1.5 2000/01/10 15:06:37 sbogun Exp $   
!+++ FORS_OUTNAME  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT         $RCSfile: fors_outname.prg,v $
!
!.KEYWORDS      Get name of pipeline output frame from result catalog
!
!.USAGE         @p fors_outname catalog base bdf_out
!
!.INPUT         catalog (P1): resilt catalog
!               base    (P2): base name of pipeline output names
!               bdf_out (P3): name of BDF-output file
!
!.OUTPUT        
!
!.RETURN        Q1:  entry number from result catalog, start counting at 0
!                    (-2: if catalog is empty, -1: if entry not found)
!               OUT_A: name of pipeline output file (FITS) [without path]
!               OUT_B: output path of pipeline
!
!.DEFAULT
!
!.PURPOSE       Get catalog entry number or the corresponding entry itself
!
!.ALGORITHM     X
!
!.ENVIRON       FORS, CCDRED context
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       1.0 1998/10/06  Creation
!
!.COMMENT
!------------------------------------------------------------------------------
!
! Check parameters
!
define/parameter p1 ? c "Enter catalog name:"
define/parameter p2 ? c "Enter pipeline output base name: "
define/parameter p3 ? c "Enter name of BDF-output name: "

define/local EXT/c/1/5 .fits
define/local num/i/1/1 0
define/local prodstr/c/1/200 " " all

set/format

write/key out_a " " ALL
write/key out_b " " ALL

@p fors_getcatentry {P1} {P3}
num = {Q1} - 1

if num .lt. 0 return {num}

write/keyw prodstr {P2}_{num}{EXT}
@p fors_parsepath {prodstr(1:97)}
out_a = Q2 // Q3                              !output name (without path)
out_b = Q1

return {num}
