! $Id: fors_parsepath.prg,v 1.6 1999/11/25 11:24:02 sbogun Exp $   
!+++ FORS_PARSEPATH +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT       $RCSfile: fors_parsepath.prg,v $
!
!.KEYWORDS      Parse path
!
!.USAGE         @p fors_parsepath path
!
!.INPUT         path    (P1): path to be parsed
!
!.OUTPUT        
!
!.RETURN        Q1:     directory
!               Q2:     filename
!               Q3:     extension
!               OUTPUTI: holds the three indizes indx1, indx2, indx3
!                       indx1: position in path of end of directory string
!                       indx2: position in path of end of filename string
!                               without extension.
!                       indx3: length of path
!
!.DEFAULT
!
!.PURPOSE       Find parts of a path: directory, filename and extension.
!
!.ALGORITHM     
!
!.ENVIRON       
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       0.5 1997/11/18  Creation
!
!.COMMENT
!------------------------------------------------------------------------------
!
! Check parameters!
!
define/param p1 ? c "Enter PATH: "

define/local dir/c/1/100 " " ALL
define/local ext/c/1/20 " " ALL
define/local fnm/c/1/80 " " ALL
define/local indx1/i/1/1 0
define/local indx2/i/1/1 0
define/local indx3/i/1/1 0

indx1 = m$indexb(p1,"/")
indx2 = m$indexb(p1,".")
indx3 = m$len(p1)
write/keyw OUTPUTI/i/1/3 {indx1},{indx2},{indx3}

if indx3 .eq. 0 return {dir} {fnm} {ext}

if indx2 .gt. 0 then
  ext = P1({indx2}:{indx3})
L1:
  if indx1 .gt. 0 then
    dir = P1(1:{indx1})
    indx1 = indx1 + 1
    indx2 = indx2 - 1
    if indx2 .lt. indx1 indx2 = indx3
    fnm = P1({indx1}:{indx2})
  else
    indx2 = indx2 - 1
    fnm = P1(1:{indx2})
  endif
else
  ext = " "
  indx2 = indx3 + 1
  goto L1
endif

return {dir} {fnm} {ext}
