! $Id: fors_plotinit.prg,v 1.1 2000/04/25 17:01:27 sbogun Exp $   
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT   (C) 2000  European Southern Observatory (ESO)
!
!.IDENT       $RCSfile: fors_plotinit.prg,v $
!
!.KEYWORDS    Plotfile initialization
!
!.USAGE       initialize/plot cat_plot
!
!.INPUT       cat_plot    (P1)   file name of the plot file catalog
!             lmode       (P2)   2: Plot catalog is not created, if procedure
!                                   is called within a super recipe.
!                                1: Plot catalog is always created.
!
!.OUTPUT      none.
!
!.RETURNS     The procedure returns 0 on success, 1 otherwise.
!
!.PURPOSE     The procedure creates a catalog in the working directory
!             which is intended to be filled with plot files.
!             
!.ENVIRON     FORS context
!
!.LANGUAGE    MIDAS command language 99NOV.
!
!.AUTHOR      S.Bogun, ESO-DMO
!
!.VERSION     1.5  2000/04/14:  Creation
!
!------------------------------------------------------------------------------

define/param p1  ?  c    "Filename of plot catalog:"
define/param p2  ?  n    "Enter lmode:"


! Procedure identification
define/local procID/c/1/80	"PlotInit"



! Local variables
define/local cat_plot/c/1/32 {p1}
define/local lmode/i/1/1     {p2}
define/local pos/i/1/1       0

! return if lmode=2 and procedure invoked within a superrecipe
if lmode .eq. 2 .and. pipeline(6) .eq. 1 then
  return 0
endif



! Create Plot catalog
pos = m$indexb(cat_plot,".cat") - 1
if pos .lt. 0 then
  cat_plot = cat_plot // ".cat"
endif
create/acat {cat_plot} NULL >Null



return 0



