! $Id: fors_preset_bias.prg,v 1.10 1999/11/25 11:24:05 sbogun Exp $   
!+++ FORS_PRESET_BIAS +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT       $RCSfile: fors_preset_bias.prg,v $
!
!.KEYWORDS      Called by img_obs_reduce.prg in order to preset the bias
!
!.USAGE         @p fors_preset_bias in_frm port
!
!.INPUT         in_frm  (P1): name of input frame
!               port    (P2): port number (1, 2, 3, or 4)            C+--+D
!                                          A, B, C,    D  port        |  |
!                                                                    A+--+B
!
!.OUTPUT        
!
!.RETURN        
!
!.DEFAULT       P2      1
!
!.PURPOSE       Stores mean bias from pre-/overscan into descr. BIAS_MEAN
!
!.ALGORITHM     Checks if P1 is an existing table. In that case it assumes
!               that this table is the overscan output table from 
!               gen_qc0_overscan.prg. Here the determined mean bias is stored
!               in the descriptor BIAS_MEAN! Get the value and preset SC_BSFRM.
!
!.ENVIRON       FORS, CCDRED context
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       0.5 1998/03/16  Creation
!
!.COMMENT
!------------------------------------------------------------------------------
!
! Check parameters
!
define/param p1 ? c "Enter name INPUT frame:"
define/param p2 1 i "Enter number of port:"
!
! local variable declaration
!

SC_BSFRM = P1
if m$tstno(P1) .eq. 0 then              !P1 is not a bias constant
                                        !so P1 could be a overscan table
  if m$exist(P1) .eq. 1 then
    if m$existd(P1,"BIAS_MEAN") .eq. 1 SC_BSFRM = "{{P1},BIAS_MEAN({P2})}"
    mess/out 3 reduce -
      "Overscan table for BIAS specified;\nMean bias(port={P2}) = {SC_BSFRM}"
  endif
else
  if {P1} .eq. 0 SC_BSFRM = "not_used"
endif
