! $Id: fors_proheadfinish.prg,v 1.3 2001/08/06 14:48:16 sbogun Exp $   
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT   (C) 1998  European Southern Observatory (ESO)
!
!.IDENT       $RCSfile: fors_proheadfinish.prg,v $
!
!.KEYWORDS    Product header finalization
!
!.USAGE       finish/prohead result_cat lmode
!
!.INPUT       result_cat  (P1)   Name of result catalog
!             lmode       (P2)   2: Longlog is not finalized, if procedure is 
!                                   called within a super recipe.
!                                1: Longlog is always finalized.
!
!.OUTPUT      none.
!
!.RETURNS     The procedure returns 0 on success or 1 on error. Keyword Q1 is
!             updated with the exit status.
!
!.PURPOSE     The procedure closes the temporary file containing the
!             standard product header created by init/prohead and
!             copies the product header to all files contained in 
!             'result_cat'
!
!.ENVIRON     FORS context
!
!.LANGUAGE    MIDAS command language 98NOV.
!
!.AUTHOR      S. Bogun, ESO-DMO
!
!.VERSION     Changes:
!             $Log: fors_proheadfinish.prg,v $
!             Revision 1.3  2001/08/06 14:48:16  sbogun
!             ESO.PRO.RECi.END -> ESO.PRO.RECi.STOP
!
!             Revision 1.2  2001/05/08 16:14:59  sbogun
!             Modifications according to new product header
!             creation scheme.
!
!
!------------------------------------------------------------------------------

define/param p1 ?  c    "Enter name of product catalog:"
define/param p2 ?  n    "Enter lmode:"


! Procedure identification
define/local procid/c/1/80  "ProHeadFinish"


! Local variables
define/local result_cat/c/1/64  {p1}
define/local lmode/i/1/1        {p2}
define/local separ/c/1/72       "-"           all


! return if lmode=2 and procedure invoked within a superrecipe
if lmode .eq. 2 .and. pipeline(6) .eq. 1 then
  return 0
endif


! Standard keys
define/local h_end_date/c/1/80   "eso.pro.{reci}.stop"
inputc = m$isodate()//"            "               ! get date in ISO 8601 format
define/local v_end_date/c/1/80   "{inputc(1:30)}"
define/local i_end_date/c/1/80   "Date when recipe execution finished"


prohead/out 1 {h_end_date} {v_end_date} "{i_end_date}" 3


! Close temporary file and write to all files in 'result_cat'
prohead/out 0 {result_cat}


return 0
