! $Id: fors_purge_crea.prg,v 1.12 2000/12/14 17:02:24 nrainer Exp $
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! .COPYRIGHT  (C) 1999  European Southern Observatory (ESO)
!
! .IDENT       $RCSfile: fors_purge_crea.prg,v $
!
! .KEYWORDS   Descriptors
!
! .PURPOSE    Creation of FITS table for fors_purge.prg - one column with all
!             descriptors, columns for all frame types with descriptors to be
!             deleted marked.
!             Also an existing table "purge_out.tbl" can be modified.
! __________
!
! .USAGE      @p fors_purge_crea[,modify]
!
! .INPUT      For ",modify" purge_out.tbl must be present.
!
! .OUTPUT     purge_in.tbl -> purge_in.dat -> purge_out.dat -> purge_out.tbl ->
!             purge_out.tfits
!
! .RETURN     -
! __________
!
! .ALGORITHM  -
!
! .COMMENT    * "xemacs" absolutely necessary !
!             * Used Unix commands: which, cut, wc, sed
!
! .ENVIRON    -
!
! .LANGUAGE   MIDAS 98NOV
!
! .AUTHOR     N.Rainer  DPG/DMD/ESO
!
! .VERSION    1.3  99/04/28  Creation
!                  99/09/23  Release
!
!-------------------------------------------------------------------------------
!
!
define/local PROID/c/1/40   "purge_crea"
if m$existk("mess_level") .eq. 0 write/keyword mess_level/i/1/1 3
!
!
write/keyword out_a "no"
$ which xemacs |cut -c1-2 | write/keyword in_a
-delete Mid{mid$sess(11:12)}1Pipe
-delete midlis{mid$sess(11:12)}.prg
if in_a .eq. out_a then
        write/out " "
        mess/out 1 {PROID} "`xemacs` not available - absolutely necessary !"
    return/exit
endif
!
!
define/local desctab/c/1/64 "purge_in.tbl"
define/local allprod/i/1/1  100
define/local alldesc/i/1/1  300
define/local desccol/c/1/16 "DESCRIPTORS"
define/local basicol/c/1/16 "_BASIC_"
define/local photcol/c/1/16 "_PHOTOMETRY_"
define/local speccol/c/1/16 "_SPECTROSCOPY_"
define/local techcol/c/1/16 "_TECHNICAL_"
define/local dn/i/1/1       0
define/local seca/c/1/19    "-" all
define/local secb/c/1/20    "-" all
define/local sec/i/1/8      0 all
define/local totrows/i/1/1  0
define/local totcols/i/1/1  0
define/local omit/i/1/5     0 all
define/local secloop/i/1/1  0
define/local minus/c/1/16   "-" all
define/local pn/i/1/1       0
define/local minus1/i/1/1     -111111111
define/local minus2/i/1/1     -222222222
define/local minus3/i/1/1     -333333333
define/local minus4/i/1/1     -444444444
define/local minus5/i/1/1     -555555555
define/local minus6/i/1/1     -666666666
define/local minus7/i/1/1     -777777777
define/local minus8/i/1/1     -888888888
define/local desctxt/c/1/64 "purge_in.dat"
define/local width/i/1/1    0
set/format I1
!
!
create/table {desctab} {allprod} {alldesc} null
!
!
        mess/out 3 {PROID} "step 1 / 7 : creating product columns ..."
!                           *************************************
!
create/column {desctab} :{desccol}        " " A50 C*50
!
create/column {desctab} :{basicol}        " " A16 C*16
create/column {desctab} :BAD_PIXEL_MAP    " " I16 I*4
create/column {desctab} :BAD_PIXEL_TABLE  " " I16 I*4
create/column {desctab} :OVEREXPO_MASK    " " I16 I*4
create/column {desctab} :OVEREXPO_TABLE   " " I16 I*4
create/column {desctab} :STATISTICS_TABLE " " I16 I*4
create/column {desctab} :OVERSCAN_TABLE   " " I16 I*4
create/column {desctab} :REDUCED_BIAS     " " I16 I*4
create/column {desctab} :MASTER_BIAS      " " I16 I*4
create/column {desctab} :REDUCED_DARK     " " I16 I*4
create/column {desctab} :MASTER_DARK      " " I16 I*4
create/column {desctab} :RED_SCR_FLAT_IMG " " I16 I*4
create/column {desctab} :RED_SCR_FLAT_LSS " " I16 I*4
create/column {desctab} :RED_SCR_FLAT_MOS " " I16 I*4
create/column {desctab} :NORM_FLAT_LSS    " " I16 I*4
create/column {desctab} :NORM_FLAT_MOS    " " I16 I*4
create/column {desctab} :RED_SKY_FLAT_IMG " " I16 I*4
create/column {desctab} :MST_SCR_FLAT_IMG " " I16 I*4
create/column {desctab} :MST_SCR_FLAT_LSS " " I16 I*4
create/column {desctab} :MST_SCR_FLAT_MOS " " I16 I*4
create/column {desctab} :MST_NRM_FLAT_LSS " " I16 I*4
create/column {desctab} :MST_NRM_FLAT_MOS " " I16 I*4
create/column {desctab} :MST_SKY_FLAT_IMG " " I16 I*4
create/column {desctab} :SUP_SKY_FLAT_IMG " " I16 I*4
create/column {desctab} :MST_NHT_FLAT_IMG " " I16 I*4
create/column {desctab} :SUP_NHT_FLAT_IMG " " I16 I*4
create/column {desctab} :CHKCAL_TABLE     " " I16 I*4
create/column {desctab} :TSTMASTER_TABLE  " " I16 I*4
!
create/column {desctab} :{photcol}        " " A16 C*16
create/column {desctab} :STD_REDUCED_IMG  " " I16 I*4
create/column {desctab} :SCI_REDUCED_IMG  " " I16 I*4
create/column {desctab} :PHOTOMETRY_TABLE " " I16 I*4
create/column {desctab} :PHOT_BACKGR_IMG  " " I16 I*4
create/column {desctab} :PHOT_BACKSUB_IMG " " I16 I*4
create/column {desctab} :ALIGNED_PHOT_TBL " " I16 I*4
create/column {desctab} :EXTCOEFF_TBL_IMG " " I16 I*4
create/column {desctab} :COL_TRANS_FORM   " " I16 I*4
create/column {desctab} :SCI_FLXCAL_IMG   " " I16 I*4
create/column {desctab} :PHOT_FLXCAL_TBL  " " I16 I*4
!
create/column {desctab} :{speccol}        " " A16 C*16
create/column {desctab} :DISP_COEFF_LSS   " " I16 I*4
create/column {desctab} :DISP_COEFF_MOS   " " I16 I*4
create/column {desctab} :REDUCED_LAMP_LSS " " I16 I*4
create/column {desctab} :LINEPOS_LSS      " " I16 I*4
create/column {desctab} :LINEPOS_MOS      " " I16 I*4
create/column {desctab} :RESOL_TABLE      " " I16 I*4
create/column {desctab} :STD_REDUCED_LSS  " " I16 I*4
create/column {desctab} :STD_REDUCED_MOS  " " I16 I*4
create/column {desctab} :STD_SKY_LSS      " " I16 I*4
create/column {desctab} :STD_SKY_MOS      " " I16 I*4
create/column {desctab} :STD_EXTRACT_LSS  " " I16 I*4
create/column {desctab} :STD_EXTRACT_MOS  " " I16 I*4
create/column {desctab} :STD_SOURCE_LSS   " " I16 I*4
create/column {desctab} :STD_SOURCE_MOS   " " I16 I*4
create/column {desctab} :CHKOBS_TABLE     " " I16 I*4
create/column {desctab} :STD_ALIGNED_LSS  " " I16 I*4
create/column {desctab} :STD_ALIGNED_MOS  " " I16 I*4
create/column {desctab} :EXTCOEFF_TBL_LSS " " I16 I*4
create/column {desctab} :EXTCOEFF_TBL_MOS " " I16 I*4
create/column {desctab} :INSTR_RESPON_LSS " " I16 I*4
create/column {desctab} :INSTR_RESPON_MOS " " I16 I*4
create/column {desctab} :SCI_REDUCED_LSS  " " I16 I*4
create/column {desctab} :SCI_REDUCED_MOS  " " I16 I*4
create/column {desctab} :SCI_FLXCAL_LSS   " " I16 I*4
create/column {desctab} :SCI_FLXCAL_MOS   " " I16 I*4
!
create/column {desctab} :{techcol}        " " A16 C*16
create/column {desctab} :FOCUS_TABLE      " " I16 I*4
create/column {desctab} :CCDCTE_TABLE     " " I16 I*4
create/column {desctab} :LIN_GAIN_TABLE   " " I16 I*4
!
width = 1234  ! = 1+8(seq)+1+50(desccol)+(1+16(other_cols))*69+1
!
!
        mess/out 3 {PROID} "step 2 / 7 : creating descriptor rows ..."
!                           *************************************
!
dn = 1
!
{desctab},:{desccol},@{dn} = "AIRMASS"                 ; dn = dn+1
{desctab},:{desccol},@{dn} = "ARCFILE"                 ; dn = dn+1
{desctab},:{desccol},@{dn} = "CD*"                     ; dn = dn+1
{desctab},:{desccol},@{dn} = "DATAMAX"                 ; dn = dn+1
{desctab},:{desccol},@{dn} = "DATAMIN"                 ; dn = dn+1
{desctab},:{desccol},@{dn} = "DEC"                     ; dn = dn+1
{desctab},:{desccol},@{dn} = "EXPTIME"                 ; dn = dn+1
{desctab},:{desccol},@{dn} = "PC*"                     ; dn = dn+1
{desctab},:{desccol},@{dn} = "PIPEFILE"                ; dn = dn+1
{desctab},:{desccol},@{dn} = "RA"                      ; dn = dn+1
!
{desctab},:{desccol},@{dn} = "{seca}  O  B  S  {secb}" ; sec(1) = dn ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.OBS*"                ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.OBS.DID"             ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.OBS.GRP"             ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.OBS.ID"              ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.OBS.NAME"            ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.OBS.OBSERVER"        ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.OBS.PI-COI.ID"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.OBS.PI-COI.NAME"     ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.OBS.PROG.ID"         ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.OBS.TARG.NAME"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.OBS.TPLNO"           ; dn = dn+1
!
{desctab},:{desccol},@{dn} = "{seca}  T  P  L  {secb}" ; sec(2) = dn ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TPL*"                ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TPL.EXPNO"           ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TPL.ID"              ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TPL.NAME"            ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TPL.NEXP"            ; dn = dn+1
!
{desctab},:{desccol},@{dn} = "{seca}  D  P  R  {secb}" ; sec(3) = dn ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DPR.CATG"            ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DPR.DID"             ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DPR.TECH"            ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DPR.TYPE"            ; dn = dn+1
!
{desctab},:{desccol},@{dn} = "{seca}  T  E  L  {secb}" ; sec(4) = dn ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL*"                ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.AIRM*"           ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.AIRM.END"        ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.AIRM.START"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.ALT"             ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.AMBI*"           ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.AMBI.FWHM.END"   ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.AMBI.FWHM.START" ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.AZ"              ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.DATE"            ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.DID"             ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.DOME.STATUS"     ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.FOCU*"           ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.FOCU.ID"         ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.FOCU.LEN"        ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.FOCU.SCALE"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.FOCU.VALUE"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.GEOELEV"         ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.GEOLAT"          ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.GEOLON"          ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.ID"              ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.OPER"            ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.PARANG*"         ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.PARANG.END"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.PARANG.START"    ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.TRAK*"           ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.TRAK.RATEA"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.TRAK.RATED"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.TEL.TRAK.STATUS"     ; dn = dn+1
!
{desctab},:{desccol},@{dn} = "{seca}  A  D  A  {secb}" ; sec(5) = dn ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.ADA*"                ; dn = dn+1
!
{desctab},:{desccol},@{dn} = "{seca}  I  N  S  {secb}" ; sec(6) = dn ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.INS.COLL*"           ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.INS.FILT*"           ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.INS.FOCU*"           ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.INS.GRIS*"           ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.INS.LAMP*"           ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.INS.MODE"            ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.INS.MOS*"            ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.INS.OPTI*"           ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.INS.PIXSCALE"        ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.INS.SLIT*"           ; dn = dn+1
!
{desctab},:{desccol},@{dn} = "{seca}  D  E  T  {secb}" ; sec(7) = dn ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET*"                ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.BITS"            ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.CHIP*.DATE"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.CHIP*.ID"        ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.CHIP*.NAME"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.CHIP*.NX"        ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.CHIP*.NY"        ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.CHIP*.PSZX"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.CHIP*.PSZY"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.CHIP*.X"         ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.CHIP*.Y"         ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.CHIPS"           ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.DATE"            ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.DEC"             ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.DID"             ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.EXP*"            ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.EXP.DUMDIT"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.EXP.NO"          ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.EXP.RDTTIME"     ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.EXP.TYPE"        ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.EXP.XFERTIM"     ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.FRAM*"           ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.FRAM.ID"         ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.FRAM.TYPE"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.ID"              ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.NAME"            ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.OUT*"            ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.OUT*.CHIP"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.OUT*.CONAD"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.OUT*.GAIN"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.OUT*.ID"         ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.OUT*.NAME"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.OUT*.NX"         ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.OUT*.NY"         ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.OUT*.OVSCX"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.OUT*.PRSCX"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.OUT*.RON"        ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.OUT*.X"          ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.OUT*.Y"          ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.OUTPUTS"         ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.OUTREF"          ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.RA"              ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.READ*"           ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.READ.CLOCK"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.READ.MODE"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.READ.SPEED"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.SHUT*"           ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.SHUT.ID"         ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.SHUT.TMCLOS"     ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.SHUT.TMOPEN"     ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.SHUT.TYPE"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.SOFW.MODE"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.WIN*.BINX"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.WIN*.BINY"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.WIN*.DIT*"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.WIN*.DKTM"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.WIN*.NDIT"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.WIN*.NX"         ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.WIN*.NY"         ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.WIN*.STRX"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.WIN*.STRY"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.WIN*.UIT*"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.DET.WINDOWS"         ; dn = dn+1
!
{desctab},:{desccol},@{dn} = "{seca}  P  R  O  {secb}" ; sec(8) = dn ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.CATG"            ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.DATAMEAN"        ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.DATAMEDI"        ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.DATANCOM"        ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.DATASIG"         ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.DATE"            ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.DID"             ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.DO.ID"           ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.FC.ID"           ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.KM.ID"           ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.QC.ARCFILE"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.QC.CERTIF"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.QC.DATE"         ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.QC.EXTCOEFF"     ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.QC.ID"           ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.QC.IMG*"         ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.QC.IMGQUAL"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.QC.IMGQUNC"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.QC.LIMAG"        ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.QC.OVBIAS"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.QC.OVEREXPO"     ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.QC.OVNOISE"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.QC.SKY*"         ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.QC.SKYMEAN"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.QC.SKYMEDI"      ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.QC.SKYSIG"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.QC.STATUS"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.QC.ZPOINT"       ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.RB.ID"           ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.RBS.ID"          ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.REC*"            ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.REDLEVEL"        ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.STATUS"          ; dn = dn+1
{desctab},:{desccol},@{dn} = "ESO.PRO.TYPE"            ; dn = dn+1
!
!
        mess/out 3 {PROID} "step 3 / 7 : initializing table elements ..."
!                           ****************************************
!
set/refc {desctab} :{desccol}
show/table {desctab} >Null
totrows = outputi(2)
totcols = outputi(1)
omit(1) = outputi(4)
set/refc {desctab} :{basicol}
show/table {desctab} >Null
omit(2) = outputi(4)
set/refc {desctab} :{photcol}
show/table {desctab} >Null
omit(3) = outputi(4)
set/refc {desctab} :{speccol}
show/table {desctab} >Null
omit(4) = outputi(4)
set/refc {desctab} :{techcol}
show/table {desctab} >Null
omit(5) = outputi(4)
set/refc {desctab} seq
!
write/table {desctab} :{basicol} @1..{totrows} "{basicol}"
do secloop = 1 8
  {desctab},:{basicol},@{sec({secloop})} = "{minus}"
enddo
write/table {desctab} :{photcol} @1..{totrows} "{photcol}"
do secloop = 1 8
  {desctab},:{photcol},@{sec({secloop})} = "{minus}"
enddo
write/table {desctab} :{speccol} @1..{totrows} "{speccol}"
do secloop = 1 8
  {desctab},:{speccol},@{sec({secloop})} = "{minus}"
enddo
write/table {desctab} :{techcol} @1..{totrows} "{techcol}"
do secloop = 1 8
  {desctab},:{techcol},@{sec({secloop})} = "{minus}"
enddo
!
do pn = 1 totcols
  if pn .ne. omit(1) then
  if pn .ne. omit(2) .and. pn .ne. omit(3) then
  if pn .ne. omit(4) .and. pn .ne. omit(5) then
    compute/table {desctab} #{pn} = -seq
    do secloop = 1 8
      {desctab},#{pn},@{sec({secloop})} = {minus{secloop}}
    enddo
  endif
  endif
  endif
enddo
!
!
        mess/out 3 {PROID} "step 4 / 7 : converting to text file ..."
!                           ************************************
!
assign/print file {desctxt}
print/table {desctab} {width}
assign/print terminal
!
        mess/out 3 {PROID} " "
        mess/out 3 {PROID} "Now edit {desctxt}:"
        mess/out 3 {PROID} "  $ xemacs {desctxt} &"
        mess/out 3 {PROID} "  -> Options -> Frame_Appearance -> Truncate_Lines"
        mess/out 3 {PROID} "  -> C-x 3 ; in right window: C-x 2"
        mess/out 3 {PROID} "  -> Read desc. in left wind., prod. in right upper"
        mess/out 3 {PROID} "  ->   and edit in right lower window"
        mess/out 3 {PROID} "  -> Insert "1" for descriptors to be removed"
        mess/out 3 {PROID} " "
        mess/out 3 {PROID} "Afterwards convert to FITS table -"
        mess/out 3 {PROID} "  @p fors_{PROID},fits"
        mess/out 3 {PROID} " "
!
!
!==============================================================================
!
entry modify:
!
define/local desctxt/c/1/64  "purge_in.dat"
define/local moditab/c/1/64  "purge_out.tbl"
define/local desctab/c/1/64  "purge_in.tbl"
define/local width/i/1/1    0
width = 1234  ! = 1+8(seq)+1+50(desccol)+(1+16(other_cols))*69+1
define/local PROID/c/1/40    "purge_crea"
!
-copy {moditab} {desctab}
!
!
        mess/out 3 {PROID} "step 4 / 7 : converting to text file ..."
!                           ************************************
!
assign/print file {desctxt}
print/table {desctab} {width}
assign/print terminal
!
        mess/out 3 {PROID} " "
        mess/out 3 {PROID} "Now edit {desctxt}:"
        mess/out 3 {PROID} "  $ xemacs {desctxt} &"
        mess/out 3 {PROID} "  -> Options -> Frame_Appearance -> Truncate_Lines"
        mess/out 3 {PROID} "  -> C-x 3 ; in right window: C-x 2"
        mess/out 3 {PROID} "  -> Read desc. in left wind., prod. in right upper"
        mess/out 3 {PROID} "  ->   and edit in right lower window"
        mess/out 3 {PROID} "  -> Insert "1" for descriptors to be removed"
        mess/out 3 {PROID} " "
        mess/out 3 {PROID} "Afterwards convert to FITS table -"
        mess/out 3 {PROID} "  @p fors_{PROID},fits"
        mess/out 3 {PROID} " "
!
!
!==============================================================================
!
entry fits:
!
define/local PROID/c/1/40    "purge_crea,fits"
define/local descbak/c/1/64  "purge_in.dat"
define/local desctxt/c/1/64  "purge_out.dat"
define/local st/i/1/1        0
define/local df0/i/1/1       0
define/local gp/i/1/1        0
define/local df/i/1/1        0
define/local fr/i/1/1        0
define/local to/i/1/1        0
define/local formcode/i/1/2  0 all
define/local desccol/c/1/16  "DESCRIPTORS"
define/local basicol/c/1/16  "_BASIC_"
define/local photcol/c/1/16  "_PHOTOMETRY_"
define/local speccol/c/1/16  "_SPECTROSCOPY_"
define/local techcol/c/1/16  "_TECHNICAL_"
define/local desctab/c/1/64  "purge_out.tbl"
define/local allprod/i/1/1   100
define/local alldesc/i/1/1   300
define/local totrows/i/1/1   0
define/local totcols/i/1/1   0
define/local omit/i/1/5      0 all
define/local pn/i/1/1        0
define/local procatg/c/1/30  "DESC_PURGE_TABLE"
define/local descfits/c/1/64 "purge_out.tfits"
define/local descps/c/1/64   "purge_in.a0.ps"
set/format I1
!
!
        mess/out 3 {PROID} "step 5 / 7 : <{descbak}> is backup file -"
        mess/out 3 {PROID} "             <{desctxt}> is used"
!                           ***************************************
!
-copy {descbak} tmp.dat
$ wc -l tmp.dat |cut -f 1 -d "t" | write/keyword outputi/i/1/1
-delete Mid{mid$sess(11:12)}1Pipe
-delete midlis{mid$sess(11:12)}.prg
$ sed "1,3d;{outputi(1)}d" tmp.dat >{desctxt}
-delete tmp.dat
!
!
        mess/out 3 {PROID} "step 6 / 7 : converting to Midas table"
        mess/out 3 {PROID} "             <{desctab}> ..."
!                           **************************************
!
st  = 11  ! start character = 1+8(seq)+1     + 1
df0 = 49  ! difference zero = 50(desccol)    - 1
gp  =  2  ! gap
df  = 15  ! difference      = 16(other_cols) - 1
!
open/file purge.fmt write formcode
!
fr = st    ; to = fr+df0
write/file {formcode(1)} define/field {fr} {to} C*50 A50 :{desccol}        " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} C*16 A16 :{basicol}        " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :BAD_PIXEL_MAP    " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :BAD_PIXEL_TABLE  " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :OVEREXPO_MASK    " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :OVEREXPO_TABLE   " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :STATISTICS_TABLE " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :OVERSCAN_TABLE   " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :REDUCED_BIAS     " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :MASTER_BIAS      " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :REDUCED_DARK     " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :MASTER_DARK      " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :RED_SCR_FLAT_IMG " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :RED_SCR_FLAT_LSS " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :RED_SCR_FLAT_MOS " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :NORM_FLAT_LSS    " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :NORM_FLAT_MOS    " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :RED_SKY_FLAT_IMG " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :MST_SCR_FLAT_IMG " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :MST_SCR_FLAT_LSS " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :MST_SCR_FLAT_MOS " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :MST_NRM_FLAT_LSS " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :MST_NRM_FLAT_MOS " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :MST_SKY_FLAT_IMG " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :SUP_SKY_FLAT_IMG " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :MST_NHT_FLAT_IMG " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :SUP_NHT_FLAT_IMG " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :CHKCAL_TABLE     " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :TSTMASTER_TABLE  " "
!
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} C*16 A16 :{photcol}        " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :STD_REDUCED_IMG  " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :SCI_REDUCED_IMG  " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :PHOTOMETRY_TABLE " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :PHOT_BACKGR_IMG  " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :PHOT_BACKSUB_IMG " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :ALIGNED_PHOT_TBL " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :EXTCOEFF_TBL_IMG " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :COL_TRANS_FORM   " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :SCI_FLXCAL_IMG   " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :PHOT_FLXCAL_TBL  " "
!
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} C*16 A16 :{speccol}        " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :DISP_COEFF_LSS   " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :DISP_COEFF_MOS   " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :REDUCED_LAMP_LSS " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :LINEPOS_LSS      " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :LINEPOS_MOS      " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :RESOL_TABLE      " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :STD_REDUCED_LSS  " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :STD_REDUCED_MOS  " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :STD_SKY_LSS      " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :STD_SKY_MOS      " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :STD_EXTRACT_LSS  " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :STD_EXTRACT_MOS  " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :STD_SOURCE_LSS   " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :STD_SOURCE_MOS   " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :CHKOBS_TABLE     " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :STD_ALIGNED_LSS  " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :STD_ALIGNED_MOS  " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :EXTCOEFF_TBL_LSS " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :EXTCOEFF_TBL_MOS " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :INSTR_RESPON_LSS " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :INSTR_RESPON_MOS " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :SCI_REDUCED_LSS  " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :SCI_REDUCED_MOS  " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :SCI_FLXCAL_LSS   " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :SCI_FLXCAL_MOS   " "
!
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} C*16 A16 :{techcol}        " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :FOCUS_TABLE      " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :CCDCTE_TABLE     " "
fr = to+gp ; to = fr+df
write/file {formcode(1)} define/field {fr} {to} I*4  I16 :LIN_GAIN_TABLE   " "
!
close/file {formcode(1)}
!
create/table {desctab} {allprod} {alldesc} {desctxt} purge.fmt
-delete purge.fmt
!
!
!        mess/out 3 {PROID} "step 7 / 8 : marking descriptors to be kept ..."
!                           *******************************************
!
!set/refc {desctab} :{desccol}
!show/table {desctab} >Null
!totrows = outputi(2)
!totcols = outputi(1)
!omit(1) = outputi(4)
!set/refc {desctab} :{basicol}
!show/table {desctab} >Null
!omit(2) = outputi(4)
!set/refc {desctab} :{photcol}
!show/table {desctab} >Null
!omit(3) = outputi(4)
!set/refc {desctab} :{speccol}
!show/table {desctab} >Null
!omit(4) = outputi(4)
!set/refc {desctab} :{techcol}
!show/table {desctab} >Null
!omit(5) = outputi(4)
!set/refc {desctab} seq
!
!do pn = 1 totcols
!  if pn .ne. omit(1) then
!  if pn .ne. omit(2) .and. pn .ne. omit(3) then
!  if pn .ne. omit(4) .and. pn .ne. omit(5) then
!    compute/table {desctab} #{pn} = (#{pn}+abs(#{pn}))/2  ! -x=>0, 1=>1
!  endif
!  endif
!  endif
!enddo
!
!
        mess/out 3 {PROID} "step 7 / 7 : converting to FITS table"
        mess/out 3 {PROID} "             <{descfits}> ..."
!                           *************************************
!
create/image empty.bdf 0,0 0.,0. nodata +
write/desc empty.bdf ESO.DPR.TECH/c/1/8 "IMAGE"
write/desc empty.bdf ESO.PRO.CATG/c/1/30 "{procatg}"
write/desc empty.bdf INSTRUME/c/1/11 "FORS1"
!
outdisk/sfits empty.bdf,{desctab} {descfits} onn
-delete empty.bdf
!
!
        mess/out 3 {PROID} "  addendum : creating A0 PS file"
        mess/out 3 {PROID} "             <{descps}> ..."
!                           *************************************
!
-delete purge_in.ps
$ a2ps -1 -R --b=0 --mar=20 -b --hi=0 -l1234 -r --foo -B -o purge_in.ps purge_in.dat 2>/dev/null
!
$ psresize -w2380 -h3368 -W595 -H842 purge_in.ps {descps} 2>/dev/null
!
!
!-------------------------------------------------------------------------------
