! $Id: fors_robust_sigma.prg,v 1.1 2001/05/08 16:12:54 sbogun Exp $   
!+++ FORS_ROBUST_SIGMA +++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT         $RCSfile: fors_robust_sigma.prg,v $
!
!.KEYWORDS
!
!.USAGE         @p fors_robust_sigma image zero
!
!.INPUT         image   (P1): input image
!               zero    (P2): if set to 1 the dispersion is calculated w.r.t.
!                             0.0 rather than the central value of the vector.
!                             If Y is a vector of residuals, this should be set.
!
!.OUTPUT
!
!.RETURN        Q1:           0: successful return
!                             otherwise: a successful return failed
!               outputr(1):   contains the robust standard deviation
!
!.DEFAULT
!
!.PURPOSE       Robust computation of standard deviation
!
!.ALGORITHM     Calls fors_robust_sigma.exe
!
!.ENVIRON       FORS
!   
!.LANGUAGE      MIDAS 01FEB
!
!.AUTHOR        Stefan Bogun, ESO DMD
!
!.VERSION       Changes:
!               $Log: fors_robust_sigma.prg,v $
!               Revision 1.1  2001/05/08 16:12:54  sbogun
!               Initial version.
!
!
!.COMMENT
!------------------------------------------------------------------------------
!
! Check parameters
!
define/param p1 ? c "Enter name of input image:"
define/param p2 0 i "Enter Zero:"
!
! local variable declaration
!

define/local image/c/1/80  "{p1}"
define/local zero/i/1/1    {p2}
define/local sigma/d/1/1   0.0

run PIPE_EXE:fors_robust_sigma.exe

outputr = sigma

return {Q1}
