! $Id: fors_verbose.prg,v 1.4 1999/11/25 11:24:11 sbogun Exp $   
!+++ FORS_VERBOSE ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT       $RCSfile: fors_verbose.prg,v $
!
!.KEYWORDS      Switch keyword MESS_LEVEL to desired MESSAGE-LEVEL
!
!.USAGE         @p fors_verbose level
!
!.INPUT         level   (P1): desired message level
!                               (1..4; or: OFF,ON,VERY)
!
!                              id   output                    bell
!                             ----+-------------------------+------
!                              0: | [prgname]: text         | OFF
!                              1: | ERROR[prgname]: text    | ON
!                              2: | WARNING[prgname]: text  | OFF
!                              3: | INFO[prgname]: text     | OFF
!                              4: | INFO[prgname]: add.text | OFF
!
!.OUTPUT        
!
!.RETURN        Q1:  0: successful return
!                   -1: a successful return failed
!
!.DEFAULT
!
!.PURPOSE       Switch keyword MESS_LEVEL to desired MESSAGE-LEVEL
!
!.ALGORITHM     Sets the global keyword MESS_LEVEL in a controlled manner.
!
!.ENVIRON       FORS, CCDRED context
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       1.0 1998/07/17  Creation
!
!.COMMENT
!------------------------------------------------------------------------------
!
! Check parameters
!
define/param p1 ? c "Desired message-level (1..4; OFF,ON,VERY)"

info/key MESS_LEVEL
if mid$info(1) .eq. 0 wr/key MESS_LEVEL/i/1/1 3

if P1(1:4) .eq. "VERY" then
  MESS_LEVEL = 4
else if P1(1:3) .eq. "OFF" then
  MESS_LEVEL = 2
else if P1(1:2) .eq. "ON" then
  MESS_LEVEL = 3
else if m$tstno(P1) .eq. 1 then
  MESS_LEVEL = {P1}
  if MESS_LEVEL .le. 0 .OR. MESS_LEVEL .gt. 4 then
    MESS_LEVEL = 3
    mess/out 1 verbose "Wrong level ({P1}) selected, set to standard: 3"
  endif
else if m$tstno(P1) .eq. 0 then
  write/out -
    "ERROR   [verbose]:          Wrong usage! (P1 = 0,..,4 or ON, OFF, VERY)"
  return -1
endif

return 0
