/* $Id: fors_append.c,v 1.3 1998/10/05 14:38:32 swolf Exp $    */
/*+++ FORS_APPEND +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 
 .COPYRIGHT	(C) 1998  European Southern Observatory
 
 .IDENT		fors_append
 
 .KEYWORDS	Appends a string to another string
 
 .USAGE		run PIPE_EXE:(IDENT)
 
 .INPUT		LINE	(char) text to be appended
                LLEN	(int) length of LINE
		CBUF    (char) text to which LINE will be appended
		CLEN    (int) length of CBUF
 
 .OUTPUT	CBUF	(char) updated text
 
 .RETURN	Q1:  0: successful return
 		    -1: no space left in CBUF
 
 .PURPOSE	Appends a string to another string
 
 .ALGORITHM	Reads the MIDAS-keywords. Checks the length of each character
                buffer (LINE, CBUF) and if LINE fits into CBUF.
		If LINE fits not into CBUF then Q1 will be set to -1 and
		LINE will not be appended!
 
 .ENVIRON	MIDAS
    
 .LANGUAGE	C
 
 .AUTHOR	Sebastian Wolf, ESO-DMO
 
 .VERSION	1.0 1998/03/04 created.
 
 .COMMENT
-----------------------------------------------------------------------------*/
#include <stdio.h>
#include <errno.h>
#define	BELL  0x7

char  Version[]="1998.03.04-SW\n";

main()
{
  char   *cbuf, *line;
  int    len, clen, llen;
  int    num, id;
  int    null, unit;


  SCSPRO("append");

  SCKRDI("CLEN",1,1,&num,&clen,&unit,&null);
  cbuf = (char*) malloc( clen );
  SCKGETC("CBUF",1,clen,&len,cbuf);
  SCKRDI("LLEN",1,1,&num,&llen,&unit,&null);
  line = (char*) malloc( llen );
  SCKGETC("LINE",1,llen,&len,line);
  SCKWRC("Q1",1,"0",1,1,&unit);

  len = strlen(cbuf);
  if (clen > len){
    strncat(&cbuf[len], line, clen-len);
    SCKWRC("CBUF",1,cbuf,1,clen,&unit);
  }else
    SCKWRC("Q1",1,"-1",1,2,&unit);         /* no space left in the buffer! */

  SCSEPI();
}
