#include <stdio.h>
#define TRUE 1
#define FALSE 0
#define BELL  0x7
#define MIN(A,B) ((A)<(B)?(A):(B))      /* minimum function */
#define MAX(A,B) ((A)>(B)?(A):(B))      /* maximum function */

int   I1, I2;         /* line interval */
int   Wwidth;         /* window width */
int   Wlen;           /* window lenth */
int   Page=FALSE;     /* prompt after one page */
char  *Name;          /* filename to list */
char  Version[]="1995.08.13-SW";

main(argc,argv)
int argc;
char *argv;
{
  int  err,eof, stop, line, ch, key;
  FILE *Fp;

  key = ' ';
  I1 = 1;             /* line interval to list: [I1,I2] */
  I2 = 0;             /* I2==0 --> whole text */
  Wwidth = 80;        /* window width */

  err = cmdline(argc, argv);
  if (err<0) return(err);

  stop = FALSE;
  Fp = (FILE*) fopen(Name,"r");
  if (Fp != NULL)
    {
      line = 1;
      do
	{
	  ch = fgetc(Fp);

	  if ( ((line >= I1) && (line <= I2)) || (I2==0) && (feof(Fp)==0))
	    putc(ch,stdout);
	  else
	    if (line>I2) stop=TRUE;

	  if (ch=='\n') line++;
	  if ( (Page) && (line%Wlen==0) && (ch=='\n') )
	    {
	      fprintf(stderr,"[%s] press RETURN to continue ([q]: quit)",Name);
	      fflush(stderr);
	      key=toupper(getchar());
	      stop = (key=='Q');
	    }
	}while (feof(Fp)==0 && !stop);
      fclose(Fp);
      if ((key!='Q') && Page)
	{
	  fprintf(stderr,"[%s] EOF reached -- press RETURN",Name);
	  fflush(stderr);
	  getchar();
	  fprintf(stderr,"\n");
	}
    }
  else
    fprintf(stderr,"ERROR[list]: cannot open file: '%s'\n",Name);

  return(0);
}




int cmdline(argc, argv)
int        argc;
char       *argv[];
{ char       *s, *termcap, slen[10];
  char       *getenv();
  int        ih, i, j;
  
            
  while ( --argc > 0)
  {
    if ( (s = *++argv)[0] == '-' )
      {   switch (*++s)  
	    {   case 'L':   I1 = atoi(s+2);
	                    break;
	        case 'U':   I2 = atoi(s+2);
	                    break;
	        case 'P':   Page = TRUE;
	                    break;

	        case 'H':   history ();              /* call prg.history */
                            return (-255);
                case 'h':   help ();                 /* call help menue */
                            return (-255);
                            break;
                default:    argc = 0;                /* option list aborted */
                            fprintf (stderr,"unknown option %c , option list aborted%c\n",*s,BELL);
                            return(-255);
                            break;
            }
        }else
	  Name = s;
  }

  
/*  if ( ((I1==I2) && (I1!=0)) || ((I1<0) || (I2<0)) ) */
  if ((I1<0) || (I2<0))
    { fprintf(stderr,"ERROR[list]: wrong line indices: %d, %d%c\n",I1,I2,BELL);
      return(-1);
    }else if ((I1>I2) && (I2>0)) { ih=I1; I1=I2; I2=ih; }  /* change index */

  if (Page)
    {
      termcap=getenv("TERMCAP");
      i=strpos(termcap,"li#");
      if (i>0)
	{ 
	  j=strpos(&termcap[i],":");
	  if (j>0)
	    { strncpy(slen,&termcap[i+3],MIN(9,j-3));
	      Wlen=MAX(1,atoi(slen)-1);
	    }
	}
      else
	Wlen=23; /* dummy */
    }
  
  return(0);
}


int kopf()
{
  printf("PRORAM: list                                       %s\n",Version);
}


int history()
{
  kopf();
  printf("HISTORY\n");
  printf("* 1995.08.10-SW: created\n");
  printf("\n");
}



int help()
{
  kopf();
  printf("SYNTAX: list <filename> [-L=num -U=num -P]\n");
  printf("Lists a file defined by <filename> starting at line -L and ends\n");
  printf("reaching -U. If the -P flag is used the listing stops after each\n");
  printf("page and prompts you to continue by pressing RETURN or 'q' to quit.\n");
  printf("\n");
  printf("OPTIONS:\n");
  printf("-L=num   linenumber to start listing of <filename>   [1]\n");
  printf("-U=num   linenumber to end listing of <filename>     [last line]\n");
  printf("-P       switch on page-prompt (wait after each page)[OFF]\n");
  printf("\n");
}	  



int strpos(source,srch)
char *source, *srch;
{
  int  i, j, len1, len2, dlen, found;

  len1 = strlen(source);
  len2 = strlen(srch);
  dlen = len1 - len2;

  if (len2>len1) return(-1);     /* srch cannot fullly be a part of source! */

  j=-1;
  do
    {
      j++;
      for (i=0;(i<len2)&&(j<dlen)&&(source[j]==srch[i]);i++,j++);
/*	printf("%c %c %d %d\n",source[j],srch[i],(source[j]==srch[i]),i); */

      found=(i>=len2);           /* otherwise source[j]!=srch[i] !! */
    }while ((!found)&&(j<dlen));

  if ((j>dlen)&&(!found))
    return(-1);                  /* not found */
  else
    return(j-len2);              /* returns index, startin at 0 */
}
