#include <string.h>
#include <stdio.h>
#include <tblsys.h>
#include <tblerr.h>
#include <tbldef.h>
#include <macrogen.h>
#include <atype.h>
#include <midas_def.h>
#include <math.h>
/* #include <sunmath.h> */
#include "nrutil.h"

#define TRUE 1
#define FALSE 0
#define BELL  0x7
#define MLEN  255
#define NLEN  100
#define MXCOL 8

int   Dtid;                             /* table id of data table */
int   Icol[MXCOL];                      /* columns indices */
int   Ndcol, Ndrow;                     /* number of columns, rows in tables */
int   Mlev;                             /* message level */
char  Mes[MLEN];                        /* message buffer */
char  Datname[NLEN] = "fit.tbl";        /* filename of data table, */
char  Xcol[NLEN] = "x_coord";           /* x-coordinate */
char  Ycol[NLEN] = "y_coord";           /* y-coordinate */

char  Prgnam[]  = "roblinfit";
char  Version[] = "1998.06.25-SW";

main()
{
  int    i;
  int    coff;
  int    len, num, uni, null;
  float  *xcor, *ycor, coef[2], dev, chisq;

  SCSPRO("roblinfit");

  SCKGETC("IN_A",1,NLEN,&len,Datname);                /* data table */
  if (Datname[0] == '?'){
    sprintf(Mes,"PROGRAM: roblinfit -- %s",Version);
    SCTPUT(Mes);
    coef[0] = 0.0;
    coef[1] = 0.0;
    goto FIN;
  }
  SCKGETC("XCOL",1,NLEN,&len,Xcol);                   /* x-coor. column name */
  SCKGETC("YCOL",1,NLEN,&len,Ycol);                   /* y-coor. column name */
  SCKRDI("MESS_LEVEL",1,1,&len,&Mlev,&uni,&null);     /* get message level */

  sprintf(Mes,"Read the data from table '%s'.",Datname);
  messout(Mlev,4,Prgnam,Mes);
  TCTOPN(Datname,F_IO_MODE,&Dtid);
  TCCSER(Dtid,Xcol,&Icol[0]);  Icol[0]--;
  TCCSER(Dtid,Ycol,&Icol[1]);  Icol[1]--;
  TCIGET(Dtid,&Ndcol,&Ndrow,&null,&null,&null);
  coff = 0;
  xcor = vector(1,Ndrow+1);
  ycor = vector(1,Ndrow+1);
  read_tablec(Dtid,-Icol[0],Ndrow,&xcor[1],&coff);
  read_tablec(Dtid,-Icol[1],Ndrow,&ycor[1],&coff);
  TCTCLO(Dtid);

  strncpy(Mes,"Perform robust linear least square fit.",MLEN);
  messout(Mlev,3,Prgnam,Mes);

  medfitc(xcor,ycor,Ndrow,&coef[0],&coef[1],&dev,&chisq);

FIN:
  SCKWRR("OUTPUTR",coef,1,2,&uni);                   /* return coefficients */
  SCKWRR("OUTPUTR",&dev,3,1,&uni);                   /* return coefficients */
  SCKWRR("OUTPUTR",&chisq,4,1,&uni);                 /* chi^2 */

  SCSEPI();
}




int nomemory(svar,num)
int   num;
char  *svar;
{
  int nbad, uni;

  sprintf(Mes,"Cannot allocate memory for %s [%d Byte]!\n",svar,num);
  messout(Mlev,1,Prgnam,Mes);
  SCSEPI();
  exit(1);
}
