! $Id: fors_s_gen_master_dark.prg,v 1.11 1999/11/30 10:40:03 sbogun Exp $
!+++ FORS_S_GEN_MASTER_DARK +++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT         $RCSfile: fors_s_gen_master_dark.prg,v $
!
!.KEYWORDS      SUPER RECIPE: Create master dark and compare with old one
!
!.USAGE         @p (IDENT) sof_in sof_ref out avmode minnum thresh infac maxov
!
!.INPUT         sof_in  (P1): set of input frames (ascii list)
!               sof_ref (P2): set of reference frames (ascii list)
!               avmode  (P4): averaging mode (0: constant, 1: mean, 2: median).
!                             If the mode is prefixed by 1 or 2, then the scaled
!                             bias correction method is used. For details see
!                             fors_gen_cal_mkmaster.prg
!               minnum  (P5): minimum number of frames to be averaged
!               thresh  (P6): thresholds
!               intfac  (P7): interval factors for median-mode
!               maxov   (P8): maximum number of overexposed pixels in %
!
!.OUTPUT        out     (P3): path + basename of output files:
!
!.RETURN        Q1:  0: successful return
!                   -1: a successful return failed
!
!.DEFAULT
!
!.PURPOSE       Create a master frame from a series of dark frames and
!               finally compare a master frame with an already existing
!               master dark frame.
!
!.ALGORITHM     Calls MIDAS procedure fors_mastercalib.prg
!
!.ENVIRON       FORS, CCDRED context
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       1.0 1998/12/04  Creation.
!               1.2 1999/02/11  defaults removed.
!
!.COMMENT       SUPER-RECIPES:
!               All output frames will have the following naming-convention:
!
!                    {P3}_{n}.fits              while {n} counts starting at 0
!
!               They will be finally saved as soon as FinishPipeline will be
!               called at the end of the SUPER-RECIPE. Until then only
!               temporary BDF-versions of the outputs will exist in the local
!               directory. All outputs have to be protocolled adding these
!               BDF-files to the result catalog created by the first
!               InitPipeline call.
!------------------------------------------------------------------------------
!
define/param p1 ? c "Enter name of ASCII filelist with calibration frames:"
define/param p2 + c "Enter name of ASCII filelist with reference frames:"
define/param p3 ? c "Enter name of output-basename (+path):"
define/param p4 22 n "Enter averaging mode and scaling method:"
define/param p5 4 n "Enter minimum number of input frames to be averaged:"
define/param p6 ? ? "Enter thresholds (s. rrd-files):"
define/param p7 ? n "Enter mmedian-mode interval factors: "
define/param p8 3 n "Enter maximum allowed number of overexposed pixels in %:"


mess/out 3 s_gen_master_dark "Create master dark ..."

inputi(1) = 2                   !exposure type 2 = DARK
inputi(2) = 0
@p fors_mastercalib {P1} {P2} {P3} {P4} {P5} {P6} {P7} {P8}
if {Q1} .ne. 0 return -1
return 0
