! $Id: fors_s_gen_ubias_test.prg,v 1.24 1999/11/25 11:24:21 sbogun Exp $   
!+++ FORS_S_GEN_UBIAS_TEST ++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT       $RCSfile: fors_s_gen_ubias_test.prg,v $
!
!.KEYWORDS      SUPER RECIPE: Compare bias frame with master bias frame
!
!.USAGE         @p fors_s_gen_ubias_test sof_in sof_ref out thresh
!
!.INPUT         sof_in  (P1): set of input frames (ascii list)
!                               names of bias frames
!               sof_ref (P2): set of reference frames (ascii list)
!                               name of master bias frame
!               thresh  (P4): thresholds for frame quality classification,
!
!.OUTPUT        out     (P3): path + basename of output files:
!
!.RETURN        Q1:  0: successful return
!                   -1: a successful return failed
!
!.DEFAULT
!
!.PURPOSE       Compare a single bias frame with an already existing
!               master bias frame.
!
!.ALGORITHM     Calls MIDAS procedure fors_ucalib_test.prg
!
!.ENVIRON       FORS, CCDRED context
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       0.5 1997/12/18  Creation
!
!.COMMENT       SUPER-RECIPES:
!               All output frames will have the following naming-convention:
!
!                    {P3}_{n}.fits              while {n} counts starting at 0
!
!               They will be finally saved as soon as FinishPipeline will be
!               called at the end of the SUPER-RECIPE. Until then only
!               temporary BDF-versions of the outputs will exist in the local
!               directory. All outputs have to be protocolled adding these
!               BDF-files to the result catalog created by the first
!               InitPipeline call.
!------------------------------------------------------------------------------
define/param p1 ? c "Enter name of ASCII filelist with science frames:"
define/param p2 ? c "Enter name of ASCII filelist with reference frames:"
define/param p3 ? c "Enter name of output-basename (+path):"
define/param p4 7.,0.5,10.,0.034,-0.13,0.75,0.4 ? "threshh.:"

mess/out 3 s_gen_ubias_test "Compare bias frame with master bias frame ..."


@p fors_ucalib_test {P1} {P2} {P3} 1 {P4}
if {Q1} .ne. 0 return -1
return 0
