! $Id: fors_s_img_uskyflat_test.prg,v 1.6 2000/09/12 08:40:09 sbogun Exp $   
!+++ FORS_S_IMG_USKYFLAT_TEST ++++++++++++++++++++++++++++++++++++++++++++++
!
!.COPYRIGHT     (C) 1998  European Southern Observatory
!
!.IDENT         $RCSfile: fors_s_img_uskyflat_test.prg,v $
!
!.KEYWORDS      SUPER RECIPE: Compare sky flatfield with its master
!
!.USAGE         @p (IDENT) sof_in sof_ref out thresh maxov
!
!.INPUT         sof_in  (P1): set of input frames (ascii list)
!                               names of sky flatfields
!               sof_ref (P2): set of reference frames (ascii list)
!                               name of a master sky flatfield
!               thresh  (P4): thresholds for frame quality classification
!               maxov   (P5): maximum number of overexposed pixels in %
!               scale   (P6): "MED": the bias correction will be done using the 
!                                    scaled master bias. The scaling is done as
!                                    follows: 
!                                    Each of the sections of the master bias is 
!                                    divided by its median and multiplied by the
!                                    median of the corresponding pre-/overscan 
!                                    region of the input frame.
!                             "OVE": like "MED", but each of the sections of the
!                                    master bias is divided by the median of its
!                                    corresponding pre-/overscan region and
!                                    multiplied by the median of the pre-/overscan
!                                    region of the input frame.
!                             "NO":  The master bias will not be scaled.
!
!.OUTPUT        out     (P3): path + basename of output files:
!
!.RETURN        Q1:  0: successful return
!                   -1: a successful return failed
!
!.DEFAULT
!
!.PURPOSE       Compare a single sky flatfield with an already existing
!               master sky flatfield.
!
!.ALGORITHM     Calls MIDAS procedure fors_ucalib_test.prg
!
!.ENVIRON       FORS, CCDRED context
!   
!.LANGUAGE      MIDAS 98NOV
!
!.AUTHOR        Sebastian Wolf, ESO-DMO
!
!.VERSION       0.5 1997/12/18  Creation
!
!.COMMENT       SUPER-RECIPES:
!               All output frames will have the following naming-convention:
!
!                    {P3}_{n}.fits              while {n} counts starting at 0
!
!               They will be finally saved as soon as FinishPipeline will be
!               called at the end of the SUPER-RECIPE. Until then only
!               temporary BDF-versions of the outputs will exist in the local
!               directory. All outputs have to be protocolled adding these
!               BDF-files to the result catalog created by the first
!               InitPipeline call.
!---------------------------------------------------------------------------
define/param p1 ? c "Enter name of ASCII filelist with science frames:"
define/param p2 ? c "Enter name of ASCII filelist with reference frames:"
define/param p3 ? c "Enter name of output-basename (+path):"
define/param p4 7.,1.0,70.,0.034,-0.13,10.,40. ? "threshh.:"
define/param p5 3 n "Enter maximum allowed number of overexposed pixels in %:"
define/param p6 OVE c "Use scaled master bias (MED/OVE/NO):"

mess/out 3 s_img_uskyflat_test -
  "Compare sky flatfield with master sky flatfield ..."

@p fors_ucalib_test {P1} {P2} {P3} 3 {P4} {P5} {P6}
if {Q1} .ne. 0 return -1
return 0
