! $Id: moscalifors.prg,v 1.7 2000/12/08 18:46:03 nrainer Exp $ (ESO-IPG)  

DEFI/PARA P1 {TOL},1.5 		N "Tolerance identify, tolerance factor guess"
DEFI/PARA P2 {WLCORD(1)},3,2 	N "Degree x,y,xy"
DEFI/PARA P3 {GRISM}		N "Grism number"
DEFI/PARA P4 7.5,280.0,0.024 	N "tilt_grism,f_camera,pixel_size"
DEFI/PARA P5 -9999,1024,1024	? "Center of optical path on CCD (x,y)"
DEFI/PARA P6 fors_grism.tbl	T "Grism table"
DEFI/PARA P7 fors_fcamera.tbl	T "table with focal length of the camera"

DEFI/PARA P8 1 			? "debug level"

!############################################################################
!# Added 00/07/17 (NR):                                                     #
!# 1. Due to one error in a lowlevel routine the very first and very last   #
!#    line of the master wavelength catalogue are not read. Therefore one   #
!#    dummy line has to be appended at the beginning and one at the end.    #
!# 2. Due to another error in "moscalifors.c, beam()" these dummy lines     #
!#    must fit through the grism; i.e., they must not be too far away from  #
!#    the actual lines.                                                     #
!# 3. In general the distance between lines should of course not be too     #
!#    low, so that misidentifications are inhibited, if "moscalifors.c"     #
!#    one day should use the dummy lines.                                   #
!# => Therefore as an acceptable compromise dummy lines in a distance of    #
!#    100 Angstrom from the first/last line have been chosen !              #
!############################################################################
! Following 5 lines to preserve lamp selection:
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
if m$index(LINECAT,".tbl") .eq. 0 LINECAT = LINECAT//".tbl"
inputi = m$indexb(LINECAT,".")-1
inputc = LINECAT(1:{inputi})//"_all.tbl"
-rename {LINECAT} {inputc}
copy/table {inputc} {LINECAT}
!
define/local DISTANCE/r/1/1 100.  ! [Angstrom]
define/local totrowno/i/1/1 {{LINECAT},TBLCONTR(4)}
!
create/row {LINECAT} @0 1
totrowno = totrowno+1
create/row {LINECAT} @{totrowno} 1
totrowno = totrowno+1
!
{LINECAT},:WAVE,@1 = {{LINECAT},:WAVE,@2}-DISTANCE
inputi = totrowno-1
{LINECAT},:WAVE,@{totrowno} = {{LINECAT},:WAVE,@{inputi}}+DISTANCE
!############################################################################

DEFI/LOCA DEBUG/I/1/1 {P8}

DEFI/LOCA IN_C/C/1/80  {P6}
DEFI/LOCA IN_D/C/1/80  {MOS}
DEFI/LOCA IN_E/C/1/80  {P7}
WRIT/KEYW OUT_A/C/1/80 {LINFIT}
WRIT/KEYW INPUTR/R/1/3 {ALPHA},{P1},1.5 
WRIT/KEYW INPUTD/D/1/4 {P4},0,0,0,0

DEFI/LOCA CENTER/D/1/3 {P5},1024.0,1024.0
DEFI/LOCA ILOG/I/1/1 0
DEFI/LOCA CTMP/C/1/32 " " ALL

IF "{POLTYP(1:1)}" .EQ. "P" THEN
	WRITE/KEYW INPUTI/I/1/4 {P2},0
ELSE IF "{POLTYP(1:1)}" .EQ. "C" THEN
	WRITE/KEYW INPUTI/I/1/4 {P2},1
ELSE
	WRITE/KEYW INPUTI/I/1/4 {P2},2
ENDIF


COPY/DK {wlc} START/D/1/2 FSTART/D/1/2
COPY/DK {wlc} STEP/D/1/2  FSTEP/D/1/2


IF "{P5}" .EQ. "-9999" THEN
  WRITE/KEY CTMP REFPIX
  ILOG = M$EXISTD(FLAT,CTMP)
  IF ILOG .EQ. 1 THEN
    CENTER(1) = {{FLAT},REFPIX(1)}
  ENDIF
ENDIF

WRITE/OUT "CENTER OF CCD X = {CENTER(1)}"


SELE/TABL {P6} :idno.eq.{P3}

WRIT/KEYW IN_A/C/1/80  {LINPOS}
WRIT/KEYW IN_B/C/1/80  {LINECAT}


RUN PIPE_EXE:moscalifors.exe

!############################################################################
!# Removal of above created dummy lines:                                    #
!############################################################################
delete/row {LINECAT} @{totrowno}
delete/row {LINECAT} @1
!############################################################################
