! $Id: mosflux.prg,v 1.8 1999/11/24 09:48:47 sbogun Exp $ (ESO-DMD)  
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!.COPYRIGHT   (C) 1998 European Southern Observatory
!.IDENT       $RCSfile: mosflux.prg,v $
!.AUTHORS     Pascal Ballester (ESO/Garching) 
!             Cristian Levin   (ESO/La Silla)
!.KEYWORDS    Spectroscopy, Long-Slit, MOS
!.PURPOSE     Performs flux calibration of 1D and 2D spectra
!.VERSION     1.0  Package Creation  19-NOV-1998  
!------------------------------------------------------------------------------

crossref raw calibrated response expcorr mode ftype fpar image

define/param p1  ?           ima "Input spectrum: "
define/param p2  ?           ima "Corrected spectrum:"
define/param p3  {response}  c   "Response frame or table:"
define/param p4  N           c   "Correct output spectrum for exposure time?"
define/param p5  RATIO       c   "Enter response type (RATIO,COLOR):"
define/param p6  {rspftyp}   c   "Enter fit type:"
define/param p7  {rspfpar}   c   "Enter order of fit[, smoothing factor]:"
define/param p8  SPECTRUM    c   "Enter reference for response fit:"
define/maxpar 8

define/local rsptmp/c/1/100  "tmp_response.bdf"

define/local pos/i/1/1        0
define/local expflg/i/1/1     0
define/local keep/i/1/1       0
define/local fstart/d/1/1     0.
define/local fstep/d/1/1      0.
define/local fnpix/d/1/1      0.
define/local exptime/d/1/1    0.
define/local key/c/1/1        " "
define/local rspfrm/c/1/100   " " all
define/local irspfrm/c/1/100  " " all
define/local orspfrm/c/1/100  " " all


verify/mos {p1} ima
verify/mos {p1} o_time

key = m$upper(p4(1:1))
if key .eq. "Y" then
  expflg = 1
  exptime = m$value({p1},o_time(7))
endif

pos = m$index(p3,",") - 1
if pos .lt. 0 then
  irspfrm = p3
  keep = 0
else if pos .eq. 0 then
  write/out "Invalid response name given!"
  return 1
else
  irspfrm = p3(1:{pos})
  pos = pos + 2
  orspfrm = p3({pos}:)
  keep = 1
endif

if m$filtyp(irspfrm,".bdf") .eq. 2 then
  if keep .eq. 1 then
    rsptmp = orspfrm
  endif

  if p8(1:3) .eq. "SPE" then
    respfit/mos {irspfrm} {rsptmp} {p5} {p6} {p7} {p1}
  else
    respfit/mos {irspfrm} {rsptmp} {p5} {p6} {p7}
  endif
  rspfrm = rsptmp
else
  rspfrm = irspfrm
endif

if {{p1},naxis} .ne. 1 then
  fstart = m$value({p1},start(2))
  fstep = m$value({p1},step(2))
  fnpix = m$value({p1},npix(2))
  grow/image &rsp = {rspfrm} {fstart},{fstep},{fnpix}
  compute/image {p2} = {p1} / &rsp >Null
  delete/image &rsp no
else
  compute/image {p2} = {p1} / {rspfrm} >Null
endif

if expflg .eq. 1 then
  compute/image {p2} = {p2} / {exptime}
  {p2},o_time(7) = 1.
  copy/dd {p1} *,3,o_time {p2}
else
  copy/dd {p1} *,3 {p2}
endif


! Cleanup
if keep .eq. 0 then
  -delete {rsptmp}
endif

if expflg .eq. 1 then
  outputd(1) = exptime
endif

return 0
