! $Id: mosintegr.prg,v 1.5 1999/11/24 09:48:48 sbogun Exp $   
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++
!.COPYRIGHT   (C) 1999 European Southern Observatory
!.IDENT       $RCSfile: mosintegr.prg,v $
!.AUTHORS     Pascal Ballester (ESO/Garching) 
!             Cristian Levin   (ESO/La Silla)
!.KEYWORDS    Spectroscopy, Long-Slit, MOS
!.PURPOSE     Implements command INTEGRATE/MOS
!             Do the integration of a image, necessary for  
!             generating the response curve.
!.VERSION     1.0  Package Creation  17-MAR-1993
!             1.1  Adapted for MOS package 12-JAN-1999
!-------------------------------------------------------

crossref std refflux response exptime

define/param p1 ?         ima "Name of extracted, rebinned standard star:"
define/param p2 {refflux} tab "Enter standard star flux table:"
define/param p3 {resptab} tab "Output response table:"
define/param p4 N         c   "Correct for exposure time?"
define/maxpar 4

! Column labels for standard star flux table
define/local fxwave/c/1/10 ":LAMBDA"
define/local fxflux/c/1/10 ":F_LAMBDA"
define/local fxbwidth/c/1/10 ":BIN_WIDTH"


verify/mos {p1} ima
set/mos refflux={P2} resptab={P3}

if m$value({p1},step(1)) .lt. 0. then
  write/out "Error: Negative wavelength steps encountered in image {P1}!"
  return 1
endif

create/table {p3}  6 {{p1},npix(1)}

if m$upper(p4(1:1)) .eq. "Y" then
  write/out "Image: {p1}. Exposure time: {{p1},o_time(7)}"
  compute/image &a = {p1}/{{p1},o_time(7)}
  in_a = "middumma.bdf"
else
  in_a = "{p1}"
endif

in_b  = refflux
out_a = resptab

run PIPE_EXE:mosintegr 

comp/table  {resptab} :colour = -2.5 * log10(:ratio)

return 0


