! $Id: mospltspe.prg,v 1.6 2000/03/10 13:09:47 sbogun Exp $ (ESO-DMD)  
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++
!.COPYRIGHT   (C) 1999 European Southern Observatory
!.IDENT       $RCSfile: mospltspe.prg,v $
!.AUTHORS     Pascal Ballester (ESO/Garching) 
!             Cristian Levin   (ESO/La Silla)
!.KEYWORDS    Spectroscopy, Long-Slit, MOS
!.PURPOSE     Plot spectrum table
!
!.VERSION     1.0  Package Creation  17-MAR-1993  
!             1.1  Adapted for MOS package 12-JAN-1999
!-------------------------------------------------------

crossref  spectrum wave flux

define/param p1 ?        c   "Enter spectral table:"
define/param p2 LAMBDA   c   "Enter wavelength column label:"
define/param p3 FLUX     c   "Enter flux column label:"
define/maxpar 3


! Local constants
define/local tmpspec/c/1/20  "tmp_spectrum.tbl"


! Local variables
define/local nrow/i/1/1   0
define/local wave/c/1/20  " "  all
define/local flux/c/1/20  " "  all


if p2(1:1) .eq. ":" p2 = p2(2:)
if m$existc(p1,":{p2}") .lt. 0 then
  write/out "Column :{p2} not found in {p1}!"
  return 1
else
  wave = m$upper(p2)
endif


if p3(1:1) .eq. ":" p3 = p3(2:)
if m$existc(p1,":{p3}") .lt. 0 then
  write/out "Column :{p3} not found in {p1}!"
  return 1
else
  flux = m$upper(p3)
endif


select/tab {p1} all
nrow = m$value({p1},tblcontr(4))

create/table {tmpspec} 2 {nrow} NULL
copy/tt {p1} :{wave} {tmpspec} :Wavelength
copy/tt {p1} :{flux} {tmpspec} :Flux

plot/table {tmpspec} :Wavelength :Flux

-delete {tmpspec}

return 0
